####Please read "def self.bst_tool_infos" under.
require 'sketchup.rb'
require 'building_structure_tool/tst1_mod_common_util.rb'
##require 'building_structure_tool/tst_click_to_slab.rb'
require 'building_structure_tool/tst1_class_tool.rb'
require 'building_structure_tool/tst1_class_tool_for_wdlg.rb'
require 'building_structure_tool/tst1_class_table_editor.rb'
require 'building_structure_tool/tst1_mod_extend_to_structure.rb'
require 'building_structure_tool/tst1_mod_chamfer.rb'
require 'building_structure_tool/tst1_mod_extend_to_face.rb'
require 'building_structure_tool/tst1_mod_click_two_bst_entity.rb'
require 'building_structure_tool/tst1_mod_grow_to_face.rb'
require 'building_structure_tool/tst1_mod_grow_to_structure.rb'
require 'building_structure_tool/query_attributes.rb'


#class BST_tool_infomation
#include TST1_mod_common_util
#end#class

#Attributes "BEAMS_SPECS" for GROUP
#"CLASS"--Classification like "STEEL_GIRDER" "STEEL_BEAM" ,"RC_COLUMN" ,"FONDATION GIRDER" , "STEEL_BRACE" , "FOOTING" , "WALL" , "EFFECTIVE_WALL"
#"PROFILE"--section shape like "H-100x100x6x8"
#"FL" like 0 , -150 , 100
#"MATERIAL" like SS400
#"ROTATE" like 0 , 90

#Attributes "BEAMS_FACES" for faces in the group.
#"LOCATION":like "FC_END",like "FC_START" "FC_TOP" "FC_BOTTOM"
#
module TAK2HATA::BuildingStrcutureTool
#Menu
class TST1_class_extend_str
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_extend_structures
end
class TST1_class_chamfer
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_chamfer
end
class TST1_class_extend_face
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_extend_to_face
end
class TST1_class_grow_face
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_grow_to_face
end
class TST1_class_grow_str
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_grow_to_str
end
class TST1_Building_dialog
	include TST1_mod_common_util
	
	def bst_tool_infos()
	###read me.
	bst_infos_main = {
"Name" => "Building structure tool",

"Description" => "draw Building structure shapes from list in text file.",

"Notice" =>"I MAKES NO GUARANTEE OF VALIDITY about this script.
Please use this script at your own risk.
Strongly Recommend Sketchup version 8 higher for using this.
The copyright of this plug-in is in TAK2HATA. 
Please use this plug-in in self-responsibility. 
I do not take any responsibility. 
You can use freely. 
Axis is very important for BST Entity.
So,do not change inner axis of BST entity.
This tool do not apply well to it When those axis modified.",

"Notice(JP)" =>"免責事項：このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。
このスクリプトの著作権はTAK2HATAにあるものとします。
ただし商用（販売など）の目的でない場合はご自由にお使いください。
改変も自由ですが、配布の際はTAK2HATAまでご連絡ください。下記にブログのアドレスを掲示します。
 http://ameblo.jp/onigiri-burning/
改変開発者の方へ：デフォルト値保存やクラス名など、名称が被らないようにご配慮お願いいたします。
BST要素のグループ内の座標軸は重要です。軸に変更を加えた場合BSTツールが正しく動かなくなることがあります",
"Others" => "
 Where download My Building Smart Modeling tool for sketchup
 Hole on Solid Tool
 http://forums.sketchucation.com/viewtopic.php?f=323&t=41582
 Building structure tool
 http://forums.sketchucation.com/viewtopic.php?f=323&t=35798

 Solid quantify
 http://forums.sketchucation.com/viewtopic.php?f=323&t=41120

 WHD Parametric Component
 Coming soon."
	 }
	bst_infos_main["Translation"] = {
"1" => "Traditional Chinese:lang_zh_16.txt
Jan 03,2013.
hcltw1963
http://sketchucation.com/forums/viewtopic.php?f=323&t=35798&start=210#p447944",
"2" => "French:lang_fr.txt
Jan 08,2013.
chon
http://sketchucation.com/forums/viewtopic.php?f=323&t=35798&start=225#p448169",
"3" => "Spanish:lang_es.txt
Jan 04,2013.
Oxer
http://sketchucation.com/forums/viewtopic.php?f=323&t=35798&start=225#p448180",
"4" => "Chinese簡体字:lang_zh_cn.txt
Jan 05,2013.
Guanjin
http://sketchucation.com/forums/viewtopic.php?f=323&t=35798",
"5" =>"Germany:lang_de.txt
Apr 18,2013.
wolfi60
http://sketchucation.com/forums/viewtopic.php?f=323&t=35798&start=240#p469194"
	}
	 #"Version" => "",
	 
	bst_infos_main["History"] = {
"1.96"=> "2014.05.25.
	fixing the problem error about show dialogs in Sketchup2014.",
"1.95"=> "Oct 24,2013.
	fixing the problem error about show dialogs in Sketchup2013.",
"1.94" => "May 22,2013.
	conform to Extension Class.",
"1.93" => "May 14,2013.
	Defined the sketchup extension class.
	QueryAttributes.rb move to building_structure_tool folder.
	So,if you installed older version,please remove that from plugins folder.",
"1.92" => "Apr 28,2013.
	add language file for Germany by wolfi60.Thanks.",
"1.90" => "Apr 19,2013.
	Change disableUI of the start_operation to true when Sketchup version 7.0 higher.",
"1.89" => "Mar 17,2013.
	UI long/short exchangable.",
"1.85" => "Mar 14,2013.
	bugs fix.",
"1.84" => "Mar 09,2013.
	add new function:Create BST Solid from FootPrint.
	and bugs fix.",
"1.7" => "Feb 19,2013.
	corresponds to 000Additionalpluginfolders.
	and other Improves.",
"1.6a" => "Jan 05,2013.
	Add translation words to lang file.
	Add the menu about Athors of Translations.",
"1.6" => "Jan 01,2013.
	update:The language translating works well.",
"1.5c" => "Dec 04,2012.
	Update:Bug fix.about Drawing in group.
	Add showing infomation about THIS and Development history.",
"1.5a" => "Nov 13,2012.
	Bugfix::Combine Walls do not work.",
"1.5" => "Oct 28,2012.
	Bugfix::inference axes,extending with already selected single entity.query attributes.Work MWALLS and SHAPES.",
"1.4" => "
	Add Table Editor.and some improves.",
"1.2" => "2012.09.17.
	Bugs? fixed.and Improves.
	Fix:Undo when Multi(Extend/Chamfer/Grow).
	Fix:Undo when change properties of many entities.
	Fix:(Extend/Chamfer/Grow) Structure entity which have devided side by user.
	Improve about create slab.",
"1.1g" => "2012.09.04.
	Bugfix about Single select Extending to face.",
"1.1f" => "
	extending multiple walls.and bug fix(slab tool when sketchup unit is 'Architectural')",
"1.1e" => "
	Column auto create bugfix.and improve.",
"1.1d" => "
	Vertical picked bugfix.",
"1.1b" => "
	Small Bug fix about color name.",
"1.01a" => "
	BUG FIX:works with imperial.
	BUG FIX::Textbox background color becomeing black problems in webdialog on mac ox x.",
"1.0a" => "
	modified all and improves.",
"0.54" => "2011.12.18
	small bug fix",
"0.53" => "2011.12.14
	Small bug fix.
	Click to Slab corrected.(about did not work to face)
	Extend tools are corrected.(did not work in Sketchup pro v6)",
"0.5" => "20011.11.13.
	small changes.
	improve wall tool. ESC key to STOP continus of wall.
	improve slab tool.
	small improve in coding.
	toolbar and menu reduced.Replace toolbar with Webdialog tool box.
	( In this code ,the menu was only comment out.so delete # of that lines, it will rebirth.)
	Add New Function.'MultiWall' Create Multi Walls easy.This object is not able to use extend_to_structure.Others are able.
	notes:Walls in MultiWall do not have same hugo each other.(if same hugo is used,Walls do not joint automaticaly.)",
"0.4" => "2011.09.30.
	add 'Add New PROFILE' in menu.toolbar is shown when sketchup starting in the next time.(optimization on MAC)",
"0.3" => "2011.09.19.",
"0.2" => "2011.01.26." 
	}
	current_ver = "0"
	hist_date = ""
	bst_infos_main["History"].each{| version , hist|
		if version > current_ver
			current_ver = version
			hist_date = hist.split("\n")[0]
		end
	}
	current_ver = current_ver + "(" + hist_date + ")" if hist_date != ""
	bst_infos_main["Version"] = current_ver
	return bst_infos_main
	end

	def show_translators()
		bvi = bst_tool_infos
		htmlcode = []
		htmlcode << '<!DOCTYPE html><html><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />'
		htmlcode << '<script type="text/javascript">'
		htmlcode << 'function openurl(utxt){'
		htmlcode << 'cmd = "skp:openurl@" + utxt;'
		htmlcode << 'window.location = cmd;}'
		htmlcode << '</script>'

		htmlcode << '</head><body><table border="1px" width="100%"><tbody>'
		htmlcode << "<tr><td>#{langconv('Thanks a lot for All Authors of Translation!!')}</td></tr>"
		htmlcode << "<tr><td>Language</td><td>Date</td><td>Auther</td><td>Link</td></tr>"
		t = 0
		bvi["Translation"].sort.each{|num,trstring|
			t += 1
			trarr = trstring.split("\n")
			htmlcode << "<tr>"
			htmlcode << "<td>" + trarr[0] + "</td>" if trarr[0]
			htmlcode << "<td>" + trarr[1] + "</td>" if trarr[1]
			htmlcode << "<td>" + trarr[2] + "</td>" if trarr[2]

			htmlcode << "<td><input type='button' name='linkbtn#{t}' value='LINK' onClick='openurl(\"" + trarr[3] + "\")' class='cssButton'>"  if trarr[3]
			htmlcode << "</tr>"
		}

		htmlcode << '</tbody></table></body></html>'
		#UI.messagebox msg
		prfkeys = { 
			:dialog_title => langconv('Thanks a lot for All Authors of Translation!!'), 
			:scrollable => true, 
			:preferences_key => 'BST_TRANSLATORS', 
			:height => 300, 
			:width => 600, 
			:left => 150, 
			:top => 150, 
			:resizable => true, 
			:mac_only_use_nswindow => true
		} 
		bst_athr_wdlg = UI::WebDialog.new( prfkeys)
		bst_athr_wdlg.set_html( htmlcode.join("\n") )
		bst_athr_wdlg.add_action_callback("openurl"){|d,p|
			UI.openURL p
		}
		if RUBY_PLATFORM[/darwin/]
			bst_athr_wdlg.show_modal
		else
			bst_athr_wdlg.show
		end
	end
	def show_about_this()
		bvi = bst_tool_infos
msg = "Name:#{bvi[ "Name" ]}

Version:#{bvi[ "Version" ]}

Notice:#{bvi[ "Notice" ]}"
		UI.messagebox msg
	end
	def show_history()
		bvi = bst_tool_infos
		htmlcode = '<!DOCTYPE html><html><head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		</head><body><table width="100%"><tbody>'
		htmlcode << "<tr><td>BST Development History:</td></tr>"
		bvi[ "History" ].sort.each{| version , history |
			htmlcode << "<tr><td>version:" + version + "</td><td></td></tr>"
			history.each_line{|line|
				htmlcode << "<tr><td></td><td>" + line + "</td></tr>"
			}
		}
		htmlcode <<'</tbody></table></body></html>'
		#UI.messagebox msg
		prfkeys = { 
			:dialog_title => langconv('About History'), 
			:scrollable => true, 
			:preferences_key => 'BST_HISTORY', 
			:height => 500, 
			:width => 500, 
			:left => 150, 
			:top => 150, 
			:resizable => true, 
			:mac_only_use_nswindow => true
		} 
		bst_hist_wdlg = UI::WebDialog.new( prfkeys)
		bst_hist_wdlg.set_html( htmlcode )
		if RUBY_PLATFORM[/darwin/]
			bst_hist_wdlg.show_modal
		else
			bst_hist_wdlg.show
		end
	end

	def show_webdialog()
		@wdlg = UI::WebDialog.new( "Building Structure tool", true, "tst_building_webdialog", 260, 100, 150, 150, true)
		#shtm.gsub!(/\'/,"\"")
		#@wdlg.set_file( File.join( File.dirname( File.expand_path(__FILE__) ), "building_structure_tool/webdialog1.htm" ))
		@wdlg.set_file( bst_file_join( bst_file_dirname( __FILE__ ), "building_structure_tool/webdialog1.htm" ))
		
	    @wdlg.add_action_callback("dialog_all"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("ALL")
	    }
	    @wdlg.add_action_callback("dialog_sgirder"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("STEEL_GIRDER")
	    }
		@wdlg.add_action_callback("dialog_sbeam"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("STEEL_BEAM")
	    }
 		@wdlg.add_action_callback("dialog_scolumn"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("STEEL_COLUMN")
	    }
 		@wdlg.add_action_callback("dialog_rcgirder"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("RC_GIRDER")
	    }
 		@wdlg.add_action_callback("dialog_rcbeam"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("RC_BEAM")
	    }
 		@wdlg.add_action_callback("dialog_rccolumn"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("RC_COLUMN")
	    }
 		@wdlg.add_action_callback("dialog_rcfooting"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("RC_FOOTING")
	    }
 		@wdlg.add_action_callback("dialog_rcwall"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("RC_WALL")
	    }
 		@wdlg.add_action_callback("dialog_rcslab"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("RC_SLAB")
	    }
 		@wdlg.add_action_callback("tool_ex2face"){|d,p|
			Sketchup.active_model.select_tool TST1_class_extend_face.new( false )
	    }
 		@wdlg.add_action_callback("tool_extend"){|d,p|
			Sketchup.active_model.select_tool TST1_class_extend_str.new
	    }
 		@wdlg.add_action_callback("tool_grow"){|d,p|
			Sketchup.active_model.select_tool TST1_class_grow_face.new( false )
	    }
 		@wdlg.add_action_callback("tool_combine"){|d,p|
			Sketchup.active_model.select_tool TST1_class_chamfer.new
	    }
 		@wdlg.add_action_callback("tool_exchange"){|d,p|
			TST_common.tst_exchange_dialog
	    } 
		@wdlg.add_action_callback("dialog_slab"){|d,p|
			Sketchup.active_model.select_tool Click2SLAB.new
	    }
		@wdlg.add_action_callback("dialog_mwall"){|d,p|
			Sketchup.active_model.select_tool TST1_class_tool.new("MWALL")
	    }
		@wdlg.add_action_callback("tool_changeprof"){|d,p|
			tst_replacer = TST1_class_replacer.new
			tst_replacer.tst_prof_replace_start()
	    }
       if RUBY_PLATFORM[/darwin/]
            @wdlg.show_modal { }
        else
            @wdlg.show { }
        end
	end


	def tst_menu_add()
		tst_get_langtxt
		tst_main_menu = UI.menu("Plugins").add_submenu("#{langconv( 'Building Structure Tool' )}")
		tst_main_menu.add_item("#{langconv('WEBDIALOG')}" ) { 
			#show_webdialog
			toolwdlg = TST1_class_tool_for_wdlg.new
			toolwdlg.show_tooldialog
		}
		tst_main_menu.add_item("#{langconv('TABLE EDITOR')}") { 
			teditwdlg = TST1_class_table_editor.new
			teditwdlg.show_tooldialog
		}
		tst_main_menu.add_item("#{langconv('CLEAR Default')}") { tst_clear_default }
		#tst_main_menu.add_item("#{langconv('Add New PROFILE')}" ) { tst_add_new_profile }
		tst_main_menu.add_item("#{langconv('Change PROFILE-LIST File')}") { change_defaultPFPath }
		tst_main_menu.add_item("#{langconv('Change Language File')}") {  select_langfile }
		tst_main_menu.add_item("#{langconv('QueryAttributes')}" ) { Sketchup.active_model.select_tool Query_attributes3.new }

		tst_main_menu.add_item("#{langconv('HELP(show to homepage)')}") {  bst_help_url }
		tst_main_menu.add_item("#{langconv('About BST')}"){ show_about_this }
		tst_main_menu.add_item("#{langconv('About History')}"){ show_history }
		tst_main_menu.add_item("#{langconv('Thanks for Authors of Translations!')}"){ show_translators }
		tst_main_menu.add_item("#{langconv('BST Solid From FootPrint')}"){ bst_solid_from_footprint }

		#UI.menu("Draw").add_item("StructureTool_TAK2") { Sketchup.active_model.select_tool(TAKTASK::BeamsTool.new) }
		#pdir = File.dirname( File.expand_path(__FILE__) )## + '/building_structure_tool'
		pdir = bst_file_dirname( __FILE__ )## + '/building_structure_tool'
		
		
		##TOOLBAR ICONS
		arr_bst_cmd = []
		arr_bst_cmd.push [ langconv("SHOW_TOOLS"), 'toolwdlg = TST1_class_tool_for_wdlg.new;toolwdlg.show_tooldialog;', pdir + "/icon_search_lg.png" ]
		arr_bst_cmd.push [ langconv("extend to face"),'Sketchup.active_model.select_tool TST1_class_extend_face.new( false )', pdir + "/icon_extendfc_lg.png" ]
		arr_bst_cmd.push [ langconv("extend to structure"),'Sketchup.active_model.select_tool TST1_class_extend_str.new', pdir + "/icon_extend_lg.png" ]
		arr_bst_cmd.push [ langconv("grow to face"),'Sketchup.active_model.select_tool TST1_class_grow_face.new( false )', pdir + "/icon_grow_lg.png" ]
		arr_bst_cmd.push [ langconv("combine each"),'Sketchup.active_model.select_tool TST1_class_chamfer.new', pdir + "/icon_chamfer_lg.png" ]
		arr_bst_cmd.push [ langconv("table editor"),'teditwdlg = TST1_class_table_editor.new;teditwdlg.show_tooldialog;', pdir + "/icon_tableeditor_lg.png" ]
		arr_bst_cmd.push [ langconv("Query Attributes"),'Sketchup.active_model.select_tool Query_attributes3.new', pdir + "/icon_queryattributes_lg.png" ]
		arr_bst_cmd.push [ langconv("BST Solid From FootPrint"),'bst_solid_from_footprint', pdir + "/icon_footprint_lg.png" ]
		arr_bst_cmd.push [ langconv("Profile Schema Edit"),'show_schemadialog;', pdir + "/icon_schemaedit_lg.png" ]
		
		tst_tb = UI::Toolbar.new(langconv("Building Structure Toolbar"))
		arr_bst_cmd.each{| bstitle , bscmds , iconpath |
			cmd_bst = UI::Command.new( bstitle ) { eval( bscmds ) }
			cmd_bst.large_icon = cmd_bst.small_icon = iconpath
			cmd_bst.status_bar_text = cmd_bst.tooltip =bstitle
			tst_tb.add_item( cmd_bst )
		}
		tst_tb.show if tst_tb.get_last_state != 0

		#cmd_tst = UI::Command.new( tsttitle) { 
			#show_webdialog
		#	toolwdlg = TST1_class_tool_for_wdlg.new;toolwdlg.show_tooldialog;
		#}
		#cmd_tst.large_icon = cmd_tst.small_icon = pdir+"/icon_search_lg.png"
		#cmd_tst.large_icon = cmd_tst.small_icon = 'building_structure_tool/icon_search_lg.png'
		#cmd_tst.status_bar_text = cmd_tst.tooltip = tsttitle
		#tst_tb.add_item( cmd_tst )
		#tst_tb.show if tst_tb.get_last_state != 0
	end
	def show_schemadialog()
		if @bst_schema_wdlg
			@bst_schema_wdlg.bring_to_front
			return
		end
		htmfile = File.join(File.dirname(__FILE__),'bst_profile_creator2.html')
		prfkeys = { 
			:dialog_title => langconv('BST Profile Schema'), 
			:scrollable => false, 
			:preferences_key => 'tst_bst_profile_schema', 
			:height => 400, 
			:width => 400, 
			:left => 150, 
			:top => 150, 
			:resizable => true, 
			:mac_only_use_nswindow => true
		} 
		@bst_schema_wdlg = UI::WebDialog.new(prfkeys)
		if RUBY_PLATFORM[/darwin/]
			@bst_schema_wdlg.set_file('/'+htmfile)
		else
			@bst_schema_wdlg.set_file(htmfile)
		end
		@bst_schema_wdlg.set_on_close{
			@bst_schema_wdlg = nil
		}
		@bst_schema_wdlg.show
	end
	def bst_solid_from_footprint
		model = Sketchup.active_model
		ents = model.active_entities
		sels = model.selection
		fcs = sels.find_all{|sel| sel.kind_of? Sketchup::Face }
		if fcs == []
			UI.messagebox langconv("Please select at least one face first.")
			return
		end
		pushlength = 1000.mm
		btag = ""
		bclass = langconv("RC_GIRDER")
		smat = "CONCRETE"
		fmat = ""
		bmat = ""
		secmat = "matCONC"
		ssdf = Sketchup.read_default( "Structure Tool" , "BST_SOLID_FROM_FOOTPRINT" )
		if ssdf
			begin
				ssdf = ssdf.pack("U*")
			rescue
			end
			testarray = eval(ssdf)

			#rescue
			#	ssdf = ssdf.split(//u)[1..-2].join
			#	testarray = ssdf.split(",")
			#	testarray.each{|tstr|
			#		tstr = tstr.split(//u)[1..-2].join
			#	}
			#end
			bclass,btag,pushlength,smat,fmat,bmat,secmat = testarray
			bclass = langconv(bclass) if bclass
		end
		prompts = [ langconv("CLASS") ,langconv("TAG") , langconv("PUSH LENGTH") , langconv("SOLID MATERIAL") , langconv("FRONT FACE MATERIAL") , langconv("BACK FACE MATERIAL") , langconv("SECTION MATERIAL") ]
		defaults = [ bclass , btag , pushlength.to_s , smat , fmat , bmat , secmat ]
		list = []
		classlist = [ "RC_GIRDER","RC_BEAM","RC_COLUMN","RC_WALL","RC_FOOTING","STEEL_GIRDER","STEEL_BEAM","STEEL_COLUMN","SLAB" ]
		
		list.push classlist.map{|cl| langconv( cl ) }.join("|")
		result = UI.inputbox prompts, defaults, list , langconv("BST Solid From FootPrint")
		return nil if result == nil || result == false
		
		if result[0]
			classlist.each{|cl|
				if result[0] == langconv(cl)
					bclass = cl
					break
				end
			}
		end
		btag = result[1] if result[1]
		pushlength = result[2].to_l if result[2] != ""
		smat = result[3] if result[3]
		fmat = result[4] if result[4]
		bmat = result[5] if result[5]
		secmat  = result[6] if result[6]
		Sketchup.write_default( "Structure Tool" , "BST_SOLID_FROM_FOOTPRINT" , [ bclass , btag , pushlength.to_s , smat , fmat , bmat , secmat ].inspect.unpack("U*"))
		#Sketchup.write_default( "Structure Tool" , "BST_SOLID_FROM_FOOTPRINT" , [ bclass , btag , pushlength.to_s , smat , fmat , bmat , secmat ].inspect.gsub( 34.chr , "'"))
		
		horizon = true
		underpush = true
		hjust = "Center"
		vjust = "Top"
		if bclass["COLUMN"]
			horizon = false
			underpush = false
			vjust = "Middle"
		elsif bclass["WALL"]
			underpush = false
			vjust = "Bottom"
		elsif bclass["SLAB"]
			horizon = false
		end
		blayer = "Structure-#{bclass}"
		model.layers.add( blayer ) if not model.layers[ blayer ]
		add_new_material( fmat ) if fmat != ""
		add_new_material( bmat ) if bmat != ""
		add_new_material( secmat ) if secmat != ""
		operation_name = langconv("BST Solid From FootPrint")
		if Sketchup.version.to_f < 7.0
			model.start_operation( operation_name )
		else
			model.start_operation( operation_name , true)
		end
		fcs.each{|fc|
			#押し出しの方式に対して面の方向を調整
			if underpush == true
				fc.reverse! if fc.normal.samedirection?( Geom::Vector3d.new(0,0,1) )
			else
				fc.reverse! if fc.normal.samedirection?( Geom::Vector3d.new(0,0,-1) )
			end
			bprofile = "RC-100x100"
			newgrp = ents.add_group( fc )
			newgrp.name = btag

			klist = []
			lpts = []
			#面の持つ直線状に並ぶ頂点は削除する
			fc.vertices.each{|vt| 
				lines = vt.edges.map{|ed| ed.line[1] }
				if lines.size == 2 and lines[0].parallel?( lines[1] )
			#	#接続するエッジが２でそのエッジ同志の方向が平行な場合。
					dpt = vt.position + fc.normal
					lpts.push [ vt.position , dpt ]
				end
			}
			if lpts != []
				begin
					lpts.flatten!
					adeds = newgrp.entities.add_edges( lpts )
					newgrp.entities.erase_entities( adeds ) if adeds
				rescue
					p lpts
				end
			end
			#fc = newgrp.entities.find{|e| e.kind_of? Sketchup::Face }
			next if not fc
			
			gtr = newgrp.transformation
			xvec = Geom::Vector3d.new(0,0,1)
			opt = Geom::Point3d.new(0,0,0)
			zvec = Geom::Vector3d.new(0,1,0)
			maxl = 0.mm
			if horizon == true
				#水平部材の場合
				if underpush == true
					zvec = fc.normal.reverse#Geom::Vector3d.new(0,0,1)
				else
					zvec = fc.normal
				end
				#選択面で一番長いエッジのベクトルをBSTの伸長方向として定義
				fc.edges.each{|ed|
					if ed.length > maxl
						xvec = ed.line[1]
						opt = ed.line[0].transform( gtr )
						maxl = ed.length
					end
				}
				bsteds = []
				#BST方向をそろっているエッジを抽出
				fc.edges.each{|ed|
					if ed.line[1].parallel?( xvec )
						bsteds.push ed
					end
				}
				if bsteds.size == 2
					#原点を決める
					pt1= bsteds[0].start.position.transform( gtr )
					if bsteds[0].line[1].samedirection?(bsteds[1].line[1])					
						pt2= bsteds[1].start.position.transform( gtr )
					else
						pt2= bsteds[1].end.position.transform( gtr )
					end
					opt.x = ( pt1.x + pt2.x ) / 2
					opt.y = ( pt1.y + pt2.y ) / 2
					opt.z = ( pt1.z + pt2.z ) / 2
				end
			else
				#垂直系部材の場合：柱とか
				#xvecはそのまま
				#原点は境界ボックスの芯とする
				opt = newgrp.local_bounds.center.transform( gtr )
				#選択面で一番長いエッジをＹ軸としてとる。いったん
				#そのエッジの勾配をＹ軸と比較して45°以下ならばY、それ以外はZとして扱う
				##軸の座標系の考えかたが垂直材の場合はX方向が垂直(Z)、YZがワールド座標系ではXYとなっている
				fc.edges.each{|ed|
					if ed.length > maxl
						zvec = ed.line[1]
						maxl = ed.length
					end
				}
				#ang = zvec.angle_between( Geom::Vector3d.new(0,1,0) ).radians
				if zvec.z == 0.0
					ang = Math.atan2( -zvec.x , zvec.y ).radians
					if ang <= 45 and ang >= -45
					elsif ang >= 135 or ang <= -135
						zvec.reverse!
					else
						zvec = zvec.cross( xvec )
						ang = Math.atan2( -zvec.x , zvec.y ).radians
						if ang >= 135 or ang <= -135
							zvec.reverse!
						end
					end
				end
			end
			pts = []
			
			#xvecとoptに合わせるようにnewgrpを変形し、fcも位置を移動する。（変形のinverseを使って）
			#xvecをグループのX軸となるようにする
			yvec = zvec.cross( xvec )
			zvec.normalize!
			xvec.normalize!
			yvec.normalize!
			newgrp.transformation = Geom::Transformation.new(xvec, yvec, zvec, opt)
			newgrp.entities.transform_entities( Geom::Transformation.new( xvec, yvec, zvec, opt.transform( gtr.inverse) ).inverse , fc )
			fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_SIDE")
			nvec2 = fc.normal
			nvec2.length = pushlength
			nvec = fc.normal
			fc.material = fmat if fmat != ""
			fc.back_material = bmat if bmat != ""
			fc.pushpull pushlength
			if horizon == true
				#水平部材の場合
				#面の法線がX軸に対して-45～45°の場合FC_STARTかFC_END
				newgrp.entities.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc2|
					#ang = fc2.normal.angle_between( xvec ).radians
					ang = fc2.normal.angle_between( Geom::Vector3d.new(1,0,0) )
					
					if ( ang >= 0.degrees ) and ( ang <= 45.degrees )
						fc2.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_END")
					elsif ( ang >= 135.degrees ) and ( ang <= 180.degrees )
						fc2.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_START")
					else
						if bclass == "RC_WALL"
							if fc2.normal.samedirection?( nvec )
								fc2.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_TOP")
							elsif fc2.normal.samedirection?( nvec.reverse )
								fc2.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_BOTTOM")
							elsif fc2.normal.samedirection?( Geom::Vector3d.new(0,-1,0) )
								fc2.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_LEFT")
							elsif fc2.normal.samedirection?( Geom::Vector3d.new(0,1,0) )
								fc2.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_RIGHT")
							end
						end
					end
				}
				pts[0] = opt.clone
				xvec2 = xvec.clone
				xvec2.length = maxl
				pts[1] = opt + xvec2
				lbbs = newgrp.local_bounds
				a = lbbs.height.to_s.gsub(/[^0123456789\.]/,"")
				b = lbbs.depth.to_s.gsub(/[^0123456789\.]/,"")
				bprofile = "RC-#{a}x#{b}"
			elsif bclass == "SLAB"
				lbbs = newgrp.local_bounds
				a = lbbs.width.to_s.gsub(/[^0123456789\.]/,"")
				bprofile = "RCSL-#{a}"
			else
				#垂直部材の場合
				newgrp.entities.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc2|
					if fc2.normal.samedirection?( nvec )
						fc2.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_END")
					elsif fc2.normal.samedirection?( nvec.reverse )
						fc2.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_START")
					end
				}
				pts[0] = opt.clone
				pts[1] = opt + nvec2
				lbbs = newgrp.local_bounds
				a = lbbs.height.to_s.gsub(/[^0123456789\.]/,"")
				b = lbbs.depth.to_s.gsub(/[^0123456789\.]/,"")
				bprofile = "RC-#{a}x#{b}"
			end
			newgrp.entities.find_all{|e| e.kind_of? Sketchup::Edge and e.smooth? == false }.each{|ed|
				ed.set_attribute( "BEAMS_FACES", "LOCATION" , "ED_OUTLINE" )
			}
			newgrp.material = secmat if secmat != ""
			newgrp.name = "#{btag}|#{bprofile}"
			newgrp.set_attribute "BEAM_SPECS","CLASS",bclass
			newgrp.set_attribute "BEAM_SPECS","HUGO",btag
			newgrp.set_attribute "BEAM_SPECS","PROFILE",bprofile
			newgrp.set_attribute "BEAM_SPECS","MATERIAL",smat
			newgrp.set_attribute "BEAM_SPECS","ROTATE",0.0
			newgrp.set_attribute "BEAM_SPECS","MIRRORZ","No"
			newgrp.set_attribute "BEAM_SPECS","PATH", pts
			newgrp.set_attribute "BEAM_SPECS","HJUST", hjust
			newgrp.set_attribute "BEAM_SPECS","VJUST", vjust
			newgrp.set_attribute "BEAM_SPECS","TOP", 0.mm
			newgrp.set_attribute "BEAM_SPECS","WIDTH", 0.mm
			newgrp.set_attribute "BEAM_SPECS","HEIGHT", 0.mm
			newgrp.set_attribute "BEAM_SPECS","SVEC", Geom::Vector3d.new( 0,1,0 )
			newgrp.set_attribute "BEAM_SPECS","CURVE",false
			newgrp.entities.find_all{|de| de.kind_of? Sketchup::Drawingelement }.each{|e| e.layer = blayer }
		}
		model.commit_operation
	end
end
#if( not file_loaded?( "building_structure_tool.rb" ) )
	tst1bd = TST1_Building_dialog.new
	tst1bd.tst_menu_add
#end
end#module
##file_loaded("building_structure_tool.rb")
