# encoding: utf-8
####
####COMMON FUCNTIONS
####
##NKFを読み込める場合はSJISへの変換を使用する。
##modified in 2013 02 19.
##require 'create_hole_on_solid2.rb'
$kconvloaded = false
=begin
if Sketchup.version.to_f > 14.0
	$kconvloaded = false
else
	begin
		require 'nkf';$kconvloaded = true
	rescue LoadError
		$kconvloaded = false
	end
end
=end

module TAK2HATA::BuildingStrcutureTool
module TST1_mod_common_util
	#include BST_HoleOnSolid2_mod
	def bst_u8tosjis( str = "")
		return "" if str == nil
		#p ::NKF::nkf('-W -s', str)
		if $nkfexist
			#p str
			return NKF.nkf('-W -s', str)
		else
			return str
		end
	end
	def tst_clear_class_default( bclass = "" )
#				results[0] = @beams_just
#				results[1] = @beams_vjust
#				results[2] = "Yes"
#				results[3] = @beams_profile
#				results[4] = @beams_mirz
#				results[5] = @beams_fixz
#				results[6] = @beams_top
#				results[7] = @beams_height
#				results[8] = @beams_rot
#				results[9] = @wall_width
#				results[10] = @profile
#				results[11] = "true" if @beams_fixz_chk == true
		results = []
		p "clear default #{bclass}"
		if bclass == "STEEL_COLUMN" or bclass == "RC_COLUMN" 
			results[0] = "Center"
			results[1] = "Middle"
			results[2] = "Yes"
			results[3] = ""
			results[4] = "No"
			results[5] = ""
			results[6] = 0.0
			results[7] = 4000.mm
			results[8] = 0.0
			results[9] = 100.mm
			results[10] = "RC-100x100"
			results[11] = "false"
			Sketchup.write_default("Structure Tool", "#{bclass}:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "RC_COLUMN:params", results.inspect.gsub(/"/, "'"))
		elsif bclass == "RC_WALL" or bclass == "MWALL" or bclass == "SHAPES"
			results[0] = "Center"
			results[1] = "Bottom"
			results[2] = "Yes"
			results[3] = ""
			results[4] = "No"
			results[5] = ""
			results[6] = 0.0
			results[7] = 4000.mm
			results[8] = 0.0
			results[9] = 100.mm
			results[10] = "RC-100x100"
			results[11] = "false"
			Sketchup.write_default("Structure Tool", "#{bclass}:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "RC_WALL:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "MWALL:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "SHAPES:params", results.inspect.gsub(/"/, "'"))
		elsif bclass == "STEEL_BEAM" or bclass == "RC_BEAM" or bclass == "STEEL_GIRDER" or bclass == "ALL" or bclass == "RC_FOOTING"
			results[0] = "Center"
			results[1] = "Top"
			results[2] = "Yes"
			results[3] = ""
			results[4] = "No"
			results[5] = ""
			results[6] = 0.0
			results[7] = 0.0.mm
			results[8] = 0.0
			results[9] = 100.mm
			results[10] = "RC-100x100"
			results[11] = "false"
			Sketchup.write_default("Structure Tool", "#{bclass}:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "STEEL_BEAM:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "RC_BEAM:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "STEEL_GIRDER:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "RC_GIRDER:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "ALL:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "RC_FOOTING:params", results.inspect.gsub(/"/, "'"))
		elsif bclass == "SLAB"
			results = []
			results[0] = ""
			results[1] = 0.mm
			results[2] = 0.mm
			results[3] = 20000.mm
			Sketchup.write_default("Structure Tool", "#{bclass}:params", results.inspect.gsub(/"/, "'"))
			#Sketchup.write_default("Structure Tool", "SLAB:params", results.inspect.gsub( 34.chr ,  "'" ))
		end
	end
	def tst_clear_default()

		result = UI.messagebox "Clear Structure dialog default?" ,MB_YESNO
		return if result == 7

		tst_clear_class_default( "STEEL_COLUMN" )
		tst_clear_class_default( "RC_COLUMN" )
		tst_clear_class_default( "RC_WALL" )
		tst_clear_class_default( "MWALL" )
		tst_clear_class_default( "SHAPES" )
		tst_clear_class_default( "STEEL_BEAM" )
		tst_clear_class_default( "RC_BEAM" )
		tst_clear_class_default( "STEEL_GIRDER" )
		tst_clear_class_default( "ALL" )
		tst_clear_class_default( "RC_FOOTING" )
		tst_clear_class_default( "SLAB" )
	end
	def bst_help_url
		wdlg = UI::WebDialog.new( "BST HELP(TAK2HATA's HP)", true, "BST HELP", 700, 700, 150, 150, true)
		wdlg.set_url "http://www.youtube.com/playlist?list=PLCftyHL9J10csPOVj4Z1L2lcKXYXp1Kxy"
		#"http://onigiriburning.so.land.to/tutorials.html"
		if RUBY_PLATFORM[/darwin/]
			wdlg.show_modal { }
		else
			wdlg.show { }
		end
	end

	def change_defaultPFPath()
		chk = false
		pflist_path_o = Sketchup.read_default("Structure Tool", "pflist_path")
		pflist_path = bst_u8tosjis( pflist_path_o )

		while chk == false
			pflist_path_o = UI.openpanel(langconv("Select TSV File(or CSV file or XML file)"), File.dirname( pflist_path ) + File::SEPARATOR , "*" )
			if pflist_path_o == nil or pflist_path_o == "" or pflist_path_o == false
				return false
			end
			pflist_path = bst_u8tosjis( pflist_path_o ) 
			if File.extname(pflist_path).upcase == ".XML"
				chk = true
			elsif File.extname(pflist_path).upcase == ".CSV"
				chk = true
			elsif File.extname(pflist_path).upcase == ".TSV"
				chk = true
			end
		end
		
		#UI.messagebox pflist_path
		#pflist_path_sjis = pflist_path
		#if $kconvloaded == true
		#	pflist_path_sjis = Kconv.tosjis(pflist_path)
		#end
		
		#UI.messagebox pflist_path
		#@textlist,@linelist,@plinelist,@circlelist = 
		if FileTest.exist?( pflist_path )
			Sketchup.write_default("Structure Tool", "pflist_path" , pflist_path_o.gsub(/\\/,'\/') )
		else
			UI.messagebox langconv( "This script can not read from filepath include MultiByte Characters." )
			return
		end
	end

	def default_pflist()
		pflist = []
		pflist.push "G1,H150x75x5x7,,SS400,0,,,"
		pflist.push "G2,H175x90x5x8,,SS400,0,,,"
		pflist.push "G3,H200x100x5.5x8,,SS400,0,,,"
		pflist.push "G4,H250x125x6x9,,SS400,0,,,"
		pflist.push "G5,H300x150x6.5x9,,SS400,0,,,"
		pflist.push "RG1,RC500x1200,,RC,0,,,"
		pflist_path = "Sample List"
		return pflist , pflist_path
	end
	def check_multibytes_strings( mstr = "" )
		
	end
	def saveProfileList( buff , is_csv = "" )
		#1まずpflist_pathが存在するか
		#YES-Rubyが認識できるパス上にあるので続行2へ
		#NO-Rubyが認識できない、あるいは実際に存在しない。3へ
		#2既存の更新日時mtime1を取得。3へ
		#3実際に存在しない場合は試にテキストファイルを作成してのち、再度存在するかテストする。
		##存在した場合。
		####mtime1がnilの場合：新規作成だったと考えて保存完了とする。return trueおわり
		####mtime1がある場合:テキストファイルに上書きしたのち更新日時mtime2を取得。で比較して
		######時刻が変化していれば保存は完了している。return trueおわり
		######時刻が変化していなければ管理者権限で保存できていない。4へ
		##存在しなかった場合4へ
		#4-別な場所への保存を促す。（ファイル保存ダイアログを表示しpflist_pathを更新する）
		##キャンセルの場合は一度もどる。return false。おわり。
		##認識可能パスでるかのチェック。pflist_pathのペアレントディレクトリが存在するかテストする。
		####NO--4へ
		####YES--１へ
		pflist_path_o = Sketchup.read_default("Structure Tool", "pflist_path")
		pflist_path = bst_u8tosjis( pflist_path_o )
		##4
		chk = false
		while chk == false
			if is_csv == "csv"
				#csvへの保存ダイアログを起動
				pflist_path_o = UI.savepanel "Please Export CSV File", "c:\\", "*.CSV"
				return false if pflist_path_o == nil #case CANSEL
				pflist_path = bst_u8tosjis( pflist_path_o )
			elsif is_csv == "tsv"
				#tsvへの保存ダイアログを起動
				pflist_path_o = UI.savepanel "Please Export TSV File", "c:\\", "*.TSV"
				return false if pflist_path_o == nil #case CANSEL
				pflist_path = bst_u8tosjis( pflist_path_o )
			elsif not pflist_path
				#pflist_pathが存在しない場合はファイル保存ダイアログを表示
				while File.dirname( pflist_path )
					pflist_path_o = UI.savepanel "Please Save TSV File(because the file path was not valid.)", "c:\\", "*.TSV"
					return false if pflist_path_o == nil #case CANSEL
					pflist_path = bst_u8tosjis( pflist_path_o )
				end
			end
			if is_csv != "csv" and File.extname(pflist_path).upcase != ".TSV"
				#拡張子がtsv出ない場合はたぶんtsvを付加する
				pflist_path = pflist_path + ".tsv"
				pflist_path_o = pflist_path_o + ".tsv"
			elsif is_csv == "csv" and File.extname(pflist_path).upcase != ".CSV"
				#拡張子がtsv出ない場合は.csvを付加する
				pflist_path = pflist_path + ".csv"
				pflist_path_o = pflist_path_o + ".csv"
			end
			##1
			mtime1 = Time.new
			if File.exists?(pflist_path)
				##2
				mtime1 = File.mtime( pflist_path )
			else
				mtime1 = nil
			end
			##3
			#newpfpath = File.join( File.dirname( pflist_path ) , "newpflist.txt" )
			f = open( pflist_path , "w+" )
			buff.each{|bf|
				if is_csv == "csv"
					f.puts '"' + bf.gsub(/\t/,'","') + '"'
				else
					f.puts bf
				end
			}
			f.close
			##4
			if File.exists?(pflist_path)
				mtime2 = File.mtime( pflist_path )
				if mtime2 
					if mtime1 and mtime1 == mtime2
					else
						if is_csv == "csv"
							UI.messagebox("File Saved to #{pflist_path_o}")
						else
							Sketchup.write_default("Structure Tool", "pflist_path" , pflist_path_o.gsub(/\\/,'\/') )
							UI.messagebox("File Saved to #{pflist_path_o}")
						end
						chk = true
						return true
					end
				end
			end
			UI.messagebox("Saving file was aborted.\n(I guess sketchup have no permission of saving this folder).\nPlease select save path.")
		end
	end
	def readProfiles( bclass , utext = "" )
		#utextはユーザー指定の検索文字列とする
		#(0)Hugo,(1)Profile,(2)FL,(3)Material of Real,(4)Rotate,(5)FrontColor,(6)BackColor,(7)SectionColor
		#pflist = []
		pflisthash = Hash.new
		bclss = ["OTHER","STEEL_GIRDER","STEEL_BEAM","STEEL_COLUMN","RC_GIRDER","RC_BEAM","RC_COLUMN","RC_WALL","RC_FOOTING","SLAB" ]
		bclss.each{|bcls|
			pflisthash[ bcls ] = []
		}
		pflisthash["ALL"] = []
		#pflistall = []
		pflist_path_o = Sketchup.read_default("Structure Tool", "pflist_path")

		pflist_path = bst_u8tosjis( pflist_path_o )
		$bst_parts_units ="mm"
		##ここで断面リストを開くファイルパスを決める
		##初回起動時にデフォルトの場所を指定している
		##フルパスの場合言語固有の文字が含まれると読めなくなるので、デフォルトの分は相対パスにしておく。
		
		if pflist_path == nil or pflist_path == ""
			#pflist_path = Sketchup.find_support_file "default_pflist.csv", "Plugins/building_structure_tool/"
			pflist_path_o = File.expand_path( "building_structure_tool/default_pflist.csv" )
			pflist_path = bst_u8tosjis( pflist_path_o )
		elsif not FileTest.exist?( pflist_path )
			UI.messagebox "#{File.basename(pflist_path )} is not Exists.So Read from Default"
			#pflist_path = Sketchup.find_support_file "default_pflist.csv", "Plugins/building_structure_tool/"
			pflist_path_o = File.expand_path( "building_structure_tool/default_pflist.csv" )
			pflist_path = bst_u8tosjis( pflist_path_o )
		end
		if not FileTest.exist?( pflist_path )
			UI.messagebox "could not find profile list file.So Select your profile list file."
			change_defaultPFPath()
			pflist_path_o = Sketchup.read_default("Structure Tool", "pflist_path")
			pflist_path = bst_u8tosjis( pflist_path_o )
		end
		if not FileTest.exist?( pflist_path )
			return default_pflist
		end
		
		if pflist_path == nil
			return default_pflist
		end
		#pflist_path = pflist_path

		model = Sketchup.active_model
		Sketchup.write_default("Structure Tool", "pflist_path" , pflist_path_o )
		if File.extname(pflist_path).upcase == ".XML"
			sheets = getXMLSpreadSheet( pflist_path )
		elsif File.extname(pflist_path).upcase == ".CSV"
			sheets = getCSVFile( pflist_path )
		elsif File.extname(pflist_path).upcase == ".TSV"
			sheets = getTSVFile( pflist_path )
		end
		if sheets == nil
			return default_pflist
		end

		section = false
		#section = true if bclass == "ALL"

	sheets.each{|sheetname , rows| 
		#p sheetname
		clss = sheetname
		clss = "OTHER" if clss == "ALL"

		rows.each{|cells|
			if cells[0][/^\#.*/]
				clss2 = cells[0].gsub(/[\#]/,"").split(",")[0]
				if clss2.upcase == "SETTINGS" and cells.size >= 3
					if cells[2] == "inch"
						$bst_parts_units = "inch"
					else
						$bst_parts_units = "mm"
					end
				elsif sheetname == "CSVFILE"
					clss = cells[0].gsub(/[\#]/,"").split(",")[0]
					clss = "OTHER" if clss == "ALL"
				end
			elsif pflisthash.keys.index( clss ) and cells.length > 0
				if cells.size < 9
					( 9 - cells.size ).times{|i| cells.push "" }
				end
				line1 = cells[0].downcase
				line2 = cells[1].downcase
				if utext == ""
					pflisthash[clss].push cells.join("\t") + "\t" + clss
					pflisthash["ALL"].push cells.join("\t") + "\t" + clss
				elsif line1.index( utext.downcase ) or line2.index( utext.downcase )
					pflisthash["ALL"].push cells.join("\t") + "\t" + clss
				end
			end
		}
	}

=begin
	sheets.each{|sheetname , rows| 
		#p sheetname

		rows.each{|cells|
			if sheetname != "CSVFILE"
				if sheetname == bclass or bclass == "ALL"
					section = true
				elsif sheetname == "ALL" and bclass == "OTHER"
					section = true
				elsif sheetname != bclass
					section = false
				end
			end
			#if cells[0] != nil
				if cells[0][/^\#.*/]
					clss2 = cells[0].gsub(/[\#]/,"").split(",")[0]
					if clss2.upcase == "SETTINGS" and cells.size >= 3
						if cells[2] == "inch"
							$bst_parts_units = "inch"
						else
							$bst_parts_units = "mm"
						end
					end
					if sheetname == "CSVFILE"
						clss2 = cells[0].gsub(/[\#]/,"").split(",")[0]
						if clss2 == bclass or ( clss2 == "ALL" and bclass == "OTHER" )
							clss = cells[0].gsub(/[\#]/,"").split(",")[0]
							section = true
						elsif bclass == "ALL"
							section = true
							clss = "ALL"
						else
							section = false
						end
					else
						clss = sheetname
					end
				elsif section == true
					if cells.size < 9
						( 9 - cells.size ).times{|i| cells.push "" }
					end
					pflistall.push cells.join("\t") + "\t" + clss
					line1 = cells[0]
					line2 = cells[1]
					if utext == ""
						pflist.push cells.join("\t") + "\t" + clss
					else
						if line1.index( utext.downcase ) or line2.index( utext.downcase )
							pflist.push cells.join("\t") + "\t" + clss
							p cells
						elsif line1.index( utext.upcase ) or line2.index( utext.upcase )
							pflist.push cells.join("\t") + "\t" + clss
						end
					end
				end
			#end
		}
	}
=end
		#############
		#if pflist["ALL"].size == 0 && utext != ""
		#	pflist["ALL"] = pflistall
		#	UI.messagebox langconv( "Nothing Match.All list will appear" )
		#end
		###############

		return pflisthash , pflist_path
	end
	def readtextfile( open_file_path = "" )
		if open_file_path == nil
			return nil
		end
		#open_file_path.gsub!(/\//,'\\')#'
		open_file_path.gsub!(/\//,File::SEPARATOR)
		if not File.exist?( open_file_path )
			p "#{open_file_path} file not exists"
			return nil
		end
		tbuff = ""
		xf = File.open(open_file_path, "r")
		Sketchup.set_status_text langconv("reading from") + ":" + open_file_path
		xf.each{|line_p|
			line_p.chomp!
			if line_p
				#line_p.strip!
				if line_p and line_p != ""
					tbuff = tbuff + line_p + "\n"
				end
			end
		}
		xf.close
		#p tbuff
		return tbuff
	end
	def getCSVFile( open_file_path = "" )
		#return Hash by sheetnames included 2 dimension array.
		#return nil when did no be gotten.
		if File.extname(open_file_path).upcase != ".CSV"
			UI.messagebox langconv("This is not CSV!")
			return nil
		end
		tbuff = readtextfile( open_file_path )
		return nil if tbuff == nil
		cells = []
		##tbuff.split(/[\n\r]+/).each{|line_p|
		tbuff.each_line{|line_p|
			if line_p != nil
				line_p.chomp!
				cells.push split_csvline( line_p )
			end
		}
		sheets = Hash.new
		sheets["CSVFILE"] = cells
		#p cells[0]
		return sheets
	end
	def getTSVFile( open_file_path = "" )
		#return Hash by sheetnames included 2 dimension array.
		#return nil when did no be gotten.
		if File.extname(open_file_path).upcase != ".TSV"
			UI.messagebox langconv("This is not TSV!")
			return nil
		end
		tbuff = readtextfile( open_file_path )
		return nil if tbuff == nil
		cells = []
		##tbuff.split(/[\n\r]+/).each{|line_p|
		tbuff.each_line{|line_p|
			if line_p != nil
				line_p.chomp!
				cells.push line_p.split("\t")
			end
		}
		sheets = Hash.new
		sheets["CSVFILE"] = cells

		#p cells[0]
		return sheets
	end

	def split_csvline( csvline )
		#proxCamma = "separator"
		proxCamma = "|||||"
		splt = []
		#p csvline
		if Sketchup.version.to_f >= 14.0
			csvline= csvline.encode("UTF-16BE", :invalid => :replace, :undef => :replace, :replace => '?').encode("UTF-8")
		end
		splt = csvline.split(/\"/)
		
		(splt.size).times{|i|
			splt[i].gsub!( "," , proxCamma ) if ( i % 2 ) == 1
		}
		jointxt = splt.join
		#p jointxt
		return [jointxt] if jointxt.index( "," ) == nil
		items = jointxt.split(",")
		
		
		items.collect!{|item| item.gsub( proxCamma , "," ) }
		items2 = []
		items.each{|it|
			it = "" if it == nil
			items2.push it.chomp
		}
		#items.each{|item| p item }
		return items2
	end
###file utility
	def bst_file_exists( fspec )
	end
	def bst_file_join( f1 , f2 = "", f3 = "" , f4 = "" , f5 = "" , f6 = "" , f7 = "" , f8 = "" , f9 = "" )
		fspec = ""
		return "" if f1 == "" or f1 == []
		return f1 if f1.class == String and f2 == ""
		fs = File::Separator
		if f1.class == Array
			f1.each{|f|
				if f != ""
					if fspec == ""
						fspec = f
					else
						fspec= fspec + fs + f
					end
				end
			}
		elsif f1.class == String
			farr = []
			farr = farr.concat( f1.split(fs) )
			farr = farr.concat( f2.split(fs) ) if f2!= ""
			farr = farr.concat( f3.split(fs) ) if f3!= ""
			farr = farr.concat( f4.split(fs) ) if f4!= ""
			farr = farr.concat( f5.split(fs) ) if f5!= ""
			farr = farr.concat( f6.split(fs) ) if f6!= ""
			farr = farr.concat( f7.split(fs) ) if f7!= ""
			farr = farr.concat( f8.split(fs) ) if f8!= ""
			farr = farr.concat( f9.split(fs) ) if f9!= ""
			farr.delete("")
			fspec = farr.join(fs)
		end
		return fspec
	end
	def bst_file_basename( fspec = "",extname="")
		return "" if fspec == ""
		fs = File::Separator
		basename = ""
		fspec.gsub(/\\/,fs)
		fspec.gsub(/\//,fs)
		fsplit = fspec.split(fs)
		basename = fsplit[fsplit.size - 1 ] if fsplit.size > 0
		bnsplit = basename.split(".")
		if bnsplit.size > 0
			ext = bnsplit.pop
			if extname == ".*"
				basename = bnsplit.join(".")
			elsif "*.#{ext}" == extname
				basename = bnsplit.join(".")
			end
		end
		basename = "" if basename == nil
		return basename
	end
	def bst_file_dirname( fspec = "")
		return "" if fspec == ""
		fs = File::Separator
		pfolder = ""
		fspec.gsub(/\\/,fs)
		fspec.gsub(/\//,fs)
		fsplit = fspec.split(fs)
		if fsplit.size > 0
			if fsplit[ fsplit.size - 1 ] == ""
				fsplit.pop
				fsplit[ fsplit.size - 1 ] = ""
			else
				fsplit[ fsplit.size - 1 ] = ""
			end
		end
		pfolder = fsplit.join(fs)
		pfolder = "" if pfolder == nil
		return pfolder
	end
	def bst_file_extname( fspec = "")
		return "" if fspec == ""
		extname = ""
		fsplit = fspec.split(".")
		extname = fsplit[ fsplit.size - 1 ] if fsplit.size > 0
		extname = "" if extname == nil
		return extname
	end
	def bst_file_plugindir()
		fspec = file_dirname(__FILE__)
		pfolder = file_dirname(fspec)
		return pfolder
	end
#'
	def getXMLSpreadSheet( open_file_path = "" )
		#return Hashed by Sheets include 2 dimension array.
		#return nil when did no be gotten.
		if File.extname(open_file_path).upcase != ".XML"
			UI.messagebox langconv("This is not xml!")
			return nil
		end
		tbuff = readtextfile( open_file_path )
		return nil if tbuff == nil
#基本的表形式としては
#<Worksheet>
#<Table>
#<Row>
#<Cell><Data>  </Data></Cell>
#</Row>
#</Table>
#</Worksheet>
#となている前提で１行にセルは１つのみとする。
#行は歯抜けになっていても詰めて考えるのでss indexは無視する。あくまで順番どおり
		sheets = Hash.new
		row = 0
		col = 0
		cells = []
		wsheets = tbuff.split(/<\/(ss:|)Worksheet>/)
		#p "wsheets.size" + wsheets.size
		wsheets.each{|ws|
			if /\<(ss:|)Worksheet ss:Name=\"([^>]*)\">/ =~ ws
			
				chksheet = true
				sheetname = $2.to_s
				#p sheetname
				sheets[ sheetname ] = []
				tbs = ws.split(/<Table[^>]*>/)
				(1..(tbs.size - 1)).each{|ti|
					tb = tbs[ti]
					if tb != nil
						rws = tb.split(/<\/Row>/)
						rws.each{|rw|
						
							ces = rw.split(/<\/Cell>/)
							(0..(ces.size - 1)).each{|ci|
								ce = ces[ci]
								if ce != nil
									if  /\<Cell([^>]*)><Data[^>].*>(.*)<\/Data>/ =~ ce
										cellatts = $1.to_s
										ele = $2.to_s
										if ele == nil

											ele = ""
										end
										#p ele
										celmerge = 1
										celindex = col
										celmerge = $1.to_i if /ss:MergeAcross=\"(\d*)\"/ =~ cellatts
										celindex = ( $1.to_i - 1 )  if /ss:Index=\"(\d*)\"/ =~ cellatts
										col = celindex
										cells[col] = ele
										col = col + celmerge
									end
								end
							}
							row += 1
							col = 0
							cells2 = []
							cells.each{|cel|
								cel = "" if cel == nil
								cells2.push cel
							}
							sheets[ sheetname ].push cells2 if cells2.join("") != ""
							cells = []
						}
					end
				}
				row = 0
				col = 0
			end
		}
		Sketchup.set_status_text "Xml is loaded."
		return sheets
	end
	def select_langfile
		lang_dir = File.dirname( File.join( File.dirname( File.expand_path(__FILE__) ) , "languages" ) )
		#Sketchup.find_support_file "lang.txt", "Plugins/building_structure_tool/languages/" )
		lang_path_o=UI.openpanel(langconv("Select Language File"),lang_dir,"*.txt")
		lang_path_o.gsub!(/\\/,"/")
		lang_path = bst_u8tosjis( lang_path_o )
		return false if lang_path == "" or lang_path == false
		Sketchup.write_default( "Structure Tool", "lang_path", lang_path_o )
		tst_get_langtxt
		UI.messagebox langconv("The language convert will be effecvie after Sketchup restarted")
	end
	def tst_get_langtxt()
		lang_path_o = File.join( File.dirname( File.expand_path(__FILE__) ) , "languages" , "lang.txt" )
		#Sketchup.find_support_file "lang.txt", "Plugins/building_structure_tool/languages/"
		lang_path_o = Sketchup.read_default("Structure Tool", "lang_path" , lang_path_o )
		lang_path_o.gsub!(/\\/,"/")
		lang_path = bst_u8tosjis( lang_path_o )
		@tst_langhash = Hash.new
		return nil if not FileTest.exist?( lang_path )
		
		lang_file=File.new(lang_path,"r")##read mode
		lang_file.each{|line|
			if line != "" and line[0] != "#" and line["\|"]
				splt = ( line.chomp ).split("\|")
				if splt[0] != "" and splt[1] != ""
					@tst_langhash[splt[0]] = splt[1]
				end
			end
		}
		lang_file.close
	end
	def langconv( tstr )
		ret = ""
		tst_get_langtxt if @tst_langhash == nil
		return tstr if @tst_langhash == nil
		#UI.messagebox tstr
		if @tst_langhash.size > 0
			ret = @tst_langhash[tstr] if @tst_langhash[tstr] != nil
			#UI.messagebox tstr
			ret = tstr if ret == ""
		else
			ret = tstr
		end
		return ret
	end
	def langconv_html(tstr)
		tsplt = tstr.split("\n")
		tsplt.each{|tsp|
			flist1 = []
			flist1 = tsp.scan(/\<input[^\>]*value=\"[^\"]+\" type=\"BUTTON\"[^\>]*\>/)#html内
			flist1.flatten!
			flist1.uniq!
			flist1.each{|fl|
				/value=\"([^\"]+)\"/ =~ fl
				if $1
					res = langconv($1)
					if res != "" and res != $1
						fl2 = fl.gsub( "value=\"#{$1}\"" , "value=\"#{res}\"" )
						tsp.gsub!( fl , fl2 )
					end
				end
			}
			flist1 = []
			flist1 = tsp.scan(/\>[^\<\n]+\</)#html内
			flist1.flatten!
			flist1.uniq!
			flist1.each{|fl|
				/\>([^\<\n]+)\</ =~ fl
				if $1
					res = langconv($1)
					if res != "" and res != $1
						fl2 = fl.gsub( ">#{$1}<" , ">#{res}<" )
						tsp.gsub!( fl , fl2 )
					end
				end
			}
			flist1 = tsp.scan(/colNames\:\[([^\]\n]*)\]/)#html内
			flist1.flatten!
			flist1.uniq!
			flist1.each{|fl|
				fl2 = fl.scan(/\"([^"]+)\"/)
				fl2.flatten!
				if fl2
					fl2.each{|fl3|
						res = langconv(fl3)
						if res != "" and res != fl3
							tsp.gsub!( "\"#{fl3}\"" , "\"#{res}\"" )
							#tsp.gsub!( f3 , fl4 )
						end
					}
				end
			}
		}
		tstr = tsplt.join("\n")
		#UI.messagebox tstr
		return tstr
	end
	def chk_extname( filename , extname )
		if filename.upcase[ ( filename.size - extname.size )..( filename.size - 1 ) ] == extname.upcase
			return filename
		else
			return File.basename( filename ) + extname
		end
	end
	def getLengthByUnits( lstr )
		return 0 if lstr == nil or lstr == ""
		l = 0
		#p $bst_parts_units
		begin
			if $bst_parts_units == "inch"
				l = lstr.to_f.inch
			else
				l = lstr.to_f.mm
			end
		rescue
			l= 0
		end
		return l
	end
	def getNumeric( lstr )
		return 0 if lstr == nil or lstr == ""
		l = 0
		begin
			l = lstr.to_f
		rescue
			l = 0
		end
		return l
	end
	#bname ,gtr,gmat,bclass,tag,bprofile,solid_mat,beams_rot,beams_mirz,pts,beams_just,beams_vjust,beams_top,wall_width,beams_height,sidevec,fmat,bmat,secmat = get_entity_bst_info( ent )

	def get_topface( cform )
		fcs = []
		cform.entities.each{|ce|
			if ce.kind_of? Sketchup::Face
				if ce.get_attribute( "BEAMS_FACES", "LOCATION" ) == "FC_TOP" and ce.edges.find_all{|ed| ed.get_attribute( "BEAMS_FACES", "LOCATION" ) == "ED_OUTLINE" } != []
					fcs.push ce
				end
			end
		}
		if fcs == []
			return nil
		else
			return fcs
		end
	end
	def get_bottomface( cform )
		fcs = []
		cform.entities.each{|ce|
			if ce.kind_of? Sketchup::Face
				if ce.get_attribute( "BEAMS_FACES", "LOCATION" ) == "FC_BOTTOM" and ce.edges.find_all{|ed| ed.get_attribute( "BEAMS_FACES", "LOCATION" ) == "ED_OUTLINE" } != []
					fcs.push ce
				end
			end
		}
		if fcs == []
			return nil
		else
			return fcs
		end
	end
	def get_startface( cform )
		fcs = []
		cform.entities.each{|ce|
			if ce.kind_of? Sketchup::Face
				if ce.get_attribute( "BEAMS_FACES", "LOCATION" ) == "FC_START" and ce.edges.find_all{|ed| ed.get_attribute( "BEAMS_FACES", "LOCATION" ) == "ED_OUTLINE" } != []
					fcs.push ce
				end
			end
		}
		if fcs == []
			return nil
		else
			return fcs
		end
	end
	def get_endface( cform )
		fcs = []
		cform.entities.each{|ce|
			if ce.kind_of? Sketchup::Face
				if ce.get_attribute( "BEAMS_FACES", "LOCATION" ) == "FC_END" and ce.edges.find_all{|ed| ed.get_attribute( "BEAMS_FACES", "LOCATION" ) == "ED_OUTLINE" } != []
					fcs.push ce
				end
			end
		}
		if fcs == []
			return nil
		else
			return fcs
		end
	end
	def intersect_onface( line , polypts )
		plane = Geom.fit_plane_to_points polypts[0],polypts[1],polypts[2]
		pt = Geom.intersect_line_plane(line, plane)
		return nil if pt == nil
		#poly = face.outer_loop.vertices.map{|e| e.position }
		return pt if Geom.point_in_polygon_2D( pt, polypts , true ) == true
		return nil
	end
	def get_entitiesbounds( ents )
		ents2 = ents.find_all{|e| e.kind_of? Sketchup::Drawingelement }
		ptmax = [0,0,0]
		ptmin = [0,0,0]
		chk = false
		ents2.each{|e|
			if chk == false
				ptmax = e.bounds.max
				ptmin = e.bounds.min
				chk = true
			else
				ptmax.x = e.bounds.max.x if ptmax.x < e.bounds.max.x
				ptmax.y = e.bounds.max.y if ptmax.y < e.bounds.max.y
				ptmax.z = e.bounds.max.z if ptmax.z < e.bounds.max.z
				
				ptmin.x = e.bounds.min.x if ptmin.x > e.bounds.min.x
				ptmin.y = e.bounds.min.y if ptmin.y > e.bounds.min.y
				ptmin.z = e.bounds.min.z if ptmin.z > e.bounds.min.z
			end
		}
		return ptmax , ptmin
	end
	def add_new_material( mname = "" )
		mats = Sketchup.active_model.materials
		if mats[ mname ] == nil
			mat = mats.add mname
			#mat.color = "white"
			#mat.color = Sketchup::Color.new(rand(40)+215, rand(40)+215, rand(40)+215)
			colornamelist = ["OrangeRed","Orange","Gold","Khaki","LemonChiffon"]
			colornamelist.push ["OliveDrab","YellowGreen","LightGreen","LimeGreen","DarkSeaGreen"]
			colornamelist.push ["DarkSlateGray","LightCyan","LightBlue","SkyBlue","LightSteelBlue"]
			colornamelist.push ["SteelBlue","CornflowerBlue","RoyalBlue","MidnightBlue","DarkSlateBlue"]
			colornamelist.push ["MediumSlateBlue","MediumPurple","Thistle","Plum"]
			colornamelist.flatten!
			clnsize = colornamelist.size
			mat.color = colornamelist[rand(clnsize)]
		else
			mat = mats[ mname ]
		end
		return mat
	end

	def get_entity_bst_info( ent , repCate = nil, repVal = nil )
		if ent.kind_of? Sketchup::Group
			bname = ent.name## = "#{hugo}|#{bprofile}"
			gtr = ent.transformation
			gmat = ent.material
			bclass = ent.get_attribute( "BEAM_SPECS","CLASS","ALL" )
			tag = ent.get_attribute( "BEAM_SPECS","HUGO","" )
			bprofile = ent.get_attribute( "BEAM_SPECS","PROFILE", "RC-100x100" )
			solid_mat = ent.get_attribute( "BEAM_SPECS","MATERIAL","" )
			beams_rot = ent.get_attribute( "BEAM_SPECS","ROTATE","0" )
			beams_mirz = ent.get_attribute( "BEAM_SPECS","MIRRORZ","No" )
			pts = ent.get_attribute( "BEAM_SPECS","PATH", nil )
			beams_just = ent.get_attribute( "BEAM_SPECS","HJUST", "Center" )
			beams_vjust = ent.get_attribute( "BEAM_SPECS","VJUST", "Middle" )
			beams_top = ent.get_attribute( "BEAM_SPECS","TOP", "0" )
			wall_width = ent.get_attribute( "BEAM_SPECS","WIDTH", "100" )
			beams_height = ent.get_attribute( "BEAM_SPECS","HEIGHT", "2000" )
			sidevec = ent.get_attribute( "BEAM_SPECS","SVEC", nil )
			fmat = ent.get_attribute( "BEAM_SPECS","FMAT", "" )
			bmat = ent.get_attribute( "BEAM_SPECS","BMAT", "" )
			secmat = ent.get_attribute( "BEAM_SPECS","SECMAT", "" )
			mat1 = Hash.new
			mat2 = Hash.new
			ent.entities.find_all{|e| e.kind_of? Sketchup::Face }.each{|e2|
				if e2.material != nil
					if mat1.key?( e2.material.name )
						mat1[e2.material.name] = mat1[e2.material.name] + 1
					else
						mat1[e2.material.name] = 1
					end
				end
				if e2.back_material != nil
					if mat2.key?( e2.back_material.name )
						mat2[e2.back_material.name] = mat2[e2.back_material.name] + 1
					else
						mat2[e2.back_material.name] = 1
					end
				end
			}
			pmat = ""
			pval = 0
			mat1.each{|key,val|
				if val > pval
					pmat = key
					pval = val
				end
			}
			fmat = pmat if fmat == "" and pmat != nil
			pmat = ""
			pval = 0
			mat2.each{|key,val|
				if val > pval
					pmat = key
					pval = val
				end
			}
			bmat = pmat if bmat == "" and pmat != nil
			if pts == nil
				ent.entities.each{|e|
					if e.typename == "ConstructionLine"
						pts[0] = e.start
						pts[1] = e.end
					end
				}
			end
			topfc = get_topface( ent )
			btmfc = get_bottomface( ent )
			stfc = get_startface( ent )
			enfc = get_endface( ent )

			if repCate != nil and repVal != nil
				if repCate == "APPLY_PROFILE"
					bprofile = repVal
				elsif repCate == "APPLY_TAG"
					tag = repVal
				elsif repCate == "APPLY_HEIGHT"
					beams_height = repVal.to_l
				elsif repCate == "APPLY_WIDTH"
					wall_width = repVal.to_l
				elsif repCate == "APPLY_ALIGN"
					beams_just , beams_vjust = just_from_number( repVal )
				elsif repCate == "APPLY_MIRROR"
					if repVal == "true"
						@beams_mirz = "Yes"
					else
						@beams_mirz = "No"
					end
				elsif repCate == "APPLY_ROTATE"
					beams_rot = repVal.to_f
				elsif repCate == "APPLY_FLOOR"
					beams_top = repVal.to_l
				elsif repCate == "APPLY_SOL_MAT"
					solid_mat = repVal
				elsif repCate == "APPLY_F_MAT"
					fmat = repVal
				elsif repCate == "APPLY_B_MAT"
					bmat = repVal
				elsif repCate == "APPLY_SEC_MAT"
					secmat = repVal
				end
			end
			return bname ,gtr,gmat,bclass,tag,bprofile,solid_mat,beams_rot,beams_mirz,pts,beams_just,beams_vjust,beams_top,wall_width,beams_height,sidevec,fmat,bmat,secmat
		end
		return nil
	end
	def replaced_props_from_ent( ent , repCate , repVal )
		bname ,gtr,gmat,bclass,tag,bprofile,solid_mat,beams_rot,beams_mirz,pts,beams_just,beams_vjust,beams_top,wall_width,beams_height,sidevec,fmat,bmat,secmat = get_entity_bst_info( ent , repCate, repVal )
		@beams_props = []
		@beams_props[0] = bclass
		@beams_props[1] = tag
		@beams_props[2] = bprofile
		@beams_props[3] = 0
		@beams_props[4] = solid_mat
		@beams_props[5] = 0
		@beams_props[6] = fmat
		@beams_props[7] = bmat
		@beams_props[8] = secmat
		@beams_props[9] = beams_just
		@beams_props[10] = beams_vjust
		@beams_props[11] = "YES"
		@beams_props[12] = beams_top
		@beams_props[13] = beams_rot
		@beams_props[14] = beams_mirz
		@beams_props[15] = wall_width
		@beams_props[16] = beams_height
		@beams_props[17] = @slab_toplevel
		@beams_props[18] = @slab_hitlevel
		@beams_props[19] = @slab_hitrange
	end
	def get_All_Properties( btdlg )
		@bclass = btdlg.get_element_value("BST_CLASS")
		@profile = btdlg.get_element_value("BST_PROFILE")
		@tag = btdlg.get_element_value("BST_TAG")
		@solid_mat = btdlg.get_element_value("BST_SOL_MAT")
		@fmat = btdlg.get_element_value("BST_F_MAT")
		@bmat = btdlg.get_element_value("BST_B_MAT")
		@secmat = btdlg.get_element_value("BST_SEC_MAT")
		@beams_rot = getNumeric( btdlg.get_element_value("BST_ROTATE"))
		if btdlg.get_element_value("CHK_MIRR") == "true"
			@beams_mirz = "Yes"
		end
		@beams_fixz_chk = false
		#p btdlg.get_element_value("CHK_FIXZ")
		if btdlg.get_element_value("CHK_FIXZ") == "true"
			@beams_fixz_chk = true
			@beams_fixz = btdlg.get_element_value("BST_FIXZ").to_l
		end
		@beams_height = btdlg.get_element_value("BST_HEIGHT").to_l
		#p "@beamsheight#{@beams_height}"
		@wall_width = btdlg.get_element_value("BST_WIDTH").to_l
		@beams_top = btdlg.get_element_value("BST_FLOOR").to_l
		@slab_toplevel = btdlg.get_element_value("BST_GENLEVEL").to_l
		@slab_hitlevel = btdlg.get_element_value("BST_CLICKLEVEL").to_l
		@slab_hitrange = btdlg.get_element_value("BST_CLICKRANGE").to_l
		val = btdlg.get_element_value("BST_JUST")
		@beams_just , @beams_vjust = just_from_number( val )

		@bclass = "ALL" if @bclass == nil
		@profile = "H-100x100x8x12" if @profile == nil
		@tag = "" if @tag == nil
		@solid_mat = "" if @solid_mat == nil
		@fmat = "" if @fmat == nil
		@bmat = "" if @bmat == nil
		@secmat = "" if @secmat== nil
		#@beams_rot = 0 if @beams_rot == nil
		@beams_mirz = "No" if @beams_mirz == nil

		#@beams_fixz = 0
		#@beams_height = 1000 if @beams_height == nil
		#@wall_width = 100 if @wall_width == nil
		#@beams_top = 0 if @beams_top == nil
		#@slab_toplevel = 0 if @slab_toplevel == nil
		#@slab_hitlevel = 0 if @slab_hitlevel == nil
		#@slab_hitrange = 20000 if @slab_hitrange == nil
		@beams_just = "Center" if @beams_just == nil
		@beams_vjust = "Bottom" if @beams_vjust == nil
		#@beams_spec = '"' + [ @tag,@profile,@beams_top,@solid_mat,@beams_rot,@fmat,@bmat,@secmat ].join('","') + '"'
		@beams_props = []
		@beams_props[0] = @bclass
		@beams_props[1] = @tag
		@beams_props[2] = @profile
		@beams_props[3] = 0
		@beams_props[4] = @solid_mat
		@beams_props[5] = 0
		@beams_props[6] = @fmat
		@beams_props[7] = @bmat
		@beams_props[8] = @secmat
		@beams_props[9] = @beams_just
		@beams_props[10] = @beams_vjust
		@beams_props[11] = "YES"
		@beams_props[12] = @beams_top
		@beams_props[13] = @beams_rot
		@beams_props[14] = @beams_mirz
		@beams_props[15] = @wall_width
		@beams_props[16] = @beams_height
		@beams_props[17] = @slab_toplevel
		@beams_props[18] = @slab_hitlevel
		@beams_props[19] = @slab_hitrange
	end
		def just_from_number( val )
			beams_just = "Right" if val == "1" or val == "4" or val == "7"
			beams_just = "Center" if val == "2" or val == "5" or val == "8"
			beams_just = "Left" if val == "3" or val == "6" or val == "9"
			beams_vjust = "Top" if val == "7" or val == "8" or val == "9"
			beams_vjust = "Middle" if val == "4" or val == "5" or val == "6"
			beams_vjust = "Bottom" if val == "1" or val == "2" or val == "3"
			return beams_just , beams_vjust
		end
		def selected_bst_entities()
			model = Sketchup.active_model
			sels = model.selection
			bsts = []
			sels.each{|sel|
				if sel.kind_of? Sketchup::ComponentInstance or sel.kind_of? Sketchup::Group
					att_crv = sel.get_attribute( "BEAM_SPECS","CLASS","" )
					if att_crv != ""
						bsts.push sel
					end
				end
			}
			return bsts
		end
		def check_abort_topbottom(ent)
			chk = false
			beams_vjust = ent.get_attribute( "BEAM_SPECS","VJUST" )#, "Middle" )
			beams_height = ent.get_attribute( "BEAM_SPECS","HEIGHT" )#, "2000" )
			chk = true if beams_vjust != @beams_vjust 
			chk = true if beams_height != @beams_height 
			p chk
			return chk
		end
		###意図的に壁の高さを変更したときに既存の壁の上と下のアタッチを中止する。
		###ALIGNの変更も同様のことを注意する
		##abort_top_bottom
		def tst_replaceAllProps( repCate = nil , repVal = nil )
			model = Sketchup.active_model
			sels = model.selection
			bsts = selected_bst_entities()
			if bsts != []
				parent = bsts[0].parent
				klist = []
				operation_name = "replace structure property"
				if Sketchup.version.to_f < 7.0
					Sketchup.active_model.start_operation operation_name
				else
					Sketchup.active_model.start_operation operation_name,true
				end
				
				bsts.each{|bstent|
					bstent.make_unique
					tgr = bstent.transformation
					topfc = get_topface( bstent )
					btmfc = get_bottomface( bstent )
					stfc = get_startface( bstent )
					enfc = get_endface( bstent )
					
					pts = bstent.get_attribute( "BEAM_SPECS","PATH",[] )
					if pts == []
						bstent.entities.each{|e|
							if e.typename == "ConstructionLine"
								pts[0] = e.start
								pts[1] = e.end
							end
						}
					end
					p repCate
					if pts != []
						if repCate != nil and repVal != nil
							if repCate == "APPLY_TAG"
								tag = repVal
								bstent.set_attribute( "BEAM_SPECS","HUGO",tag )
							elsif repCate == "APPLY_SOL_MAT"
								solid_mat = repVal
								bstent.set_attribute( "BEAM_SPECS","MATERIAL",solid_mat )
							elsif repCate == "APPLY_F_MAT"
								fmat = repVal
								bstent.set_attribute( "BEAM_SPECS","FMAT", fmat )
								add_new_material( fmat ) if fmat != ""
								bstent.entities.find_all{|e| e.kind_of? Sketchup::Face}.each{|fc|
									if fmat != ""
										fc.material = fmat
									else
										fc.material = nil
									end
								}
							elsif repCate == "APPLY_B_MAT"
								bmat = repVal
								bstent.set_attribute( "BEAM_SPECS","BMAT", bmat )
								add_new_material( bmat ) if bmat != ""
								bstent.entities.find_all{|e| e.kind_of? Sketchup::Face}.each{|fc|
									if bmat != ""
										fc.back_material = bmat
									else
										fc.back_material = nil
									end
								}
							elsif repCate == "APPLY_SEC_MAT"
								secmat = repVal
								bstent.set_attribute( "BEAM_SPECS","SECMAT", secmat )
							else
								#need change geometry
								replaced_props_from_ent( bstent , repCate , repVal )
								topfc,btmfc = nil,nil if check_abort_topbottom(bstent)
								changeheight = false
								changeheight = true if repCate == "APPLY_HEIGHT"
								#p "apply#{@beams_props[16]}"
								btsgrp = drawStructure2( pts , @beams_props , nil , tgr , topfc , btmfc , stfc , enfc , changeheight )
								@hole_on_regen = false
								holes_regenerate( bstent , btsgrp , tgr ) if @hole_on_regen == true
								klist.push bstent
							end
						else
							#change all props,need change geometry.
							topfc,btmfc = nil,nil if check_abort_topbottom(bstent)
							btsgrp = drawStructure2( pts , @beams_props , nil , tgr , topfc , btmfc , stfc , enfc )
							@hole_on_regen = false
							holes_regenerate( bstent , btsgrp , tgr ) if @hole_on_regen == true
							klist.push bstent
						end
					end
				}
				parent.entities.erase_entities klist
				Sketchup.active_model.commit_operation
			end
			#エッジが選択されていた場合
			sel = Sketchup.active_model.selection
			sellines = sel.find_all{|e| e.kind_of?( Sketchup::Edge ) or e.kind_of?( Sketchup::ConstructionLine )}
			selFaces = sel.find_all{|e| e.kind_of?( Sketchup::Face )}
			nvec = selFaces[0].normal if not selFaces == []
			if not sellines == [] #sel.empty?
				if sellines.size != 0
					auto_create_from_lines2( @beams_props , sellines , nvec )
					Sketchup.active_model.select_tool nil
				end
			end
		end
		def holes_regenerate( bstent , btsgrp , tgr )
			100.times{|t|
				holes_insp = bstent.get_attribute("BEAM_SPECS","HOLE#{t}",nil)
				if holes_insp == nil
					break
				else
					holes = eval( holes_insp )
					frames = holes[0]
					mat = holes[1]
					nplane = holes[2]
					nplane2 = [ nplane[0].transform( tgr ),	nplane[1].transform( tgr )]
					edges = frames[0]
					crvs = frames[1]
					edges2 = edges.map{|pt1,pt2| [ pt1.transform(tgr).project_to_plane( nplane2 ), pt2.transform(tgr).project_to_plane( nplane2 ) ] }
					crvs2 = crvs.map{|crv| crv.map{|pt| pt.transform(tgr).project_to_plane( nplane2 ) } }
					frames2 = [ edges2 , crvs2 ]
					#p frames2
					subtract_form_MS( btsgrp , frames2 , mat )
				end
			}
		end
		def xyz( xx , yy , zz )
			return Geom::Point3d.new( xx , yy , zz )
		end
		def vxyz( xx , yy , zz )
			return Geom::Vector3d.new( xx , yy , zz )
		end
end #module
end#module
