require 'building_structure_tool/tst1_mod_extend_face_to_plane.rb'
##Changed in 120904:Bugfix
module TAK2HATA::BuildingStrcutureTool
module TST1_mod_extend_to_face
	include TST1_mod_extend_face_to_plane
	def second_entity_clicked2( ces , ps1 , tf1 , fc2 , tf2 , exist_sels = false )
		if exist_sels == true
			operation_name = langconv("multi Extend to face")
			if Sketchup.version.to_f < 7.0
				Sketchup.active_model.start_operation operation_name
			else
				Sketchup.active_model.start_operation operation_name,true
			end
			
			ces.each{|ce|
				tf1 = ce.transformation
				ps1 = ce.bounds.center
				extend_form_to_face( ce , ps1 , tf1 , fc2 , tf2 ,true)
			}
			Sketchup.active_model.commit_operation
		else
			ce = ces[0]
			operation_name = langconv("multi Extend to face")
			if Sketchup.version.to_f < 7.0
				Sketchup.active_model.start_operation operation_name
			else
				Sketchup.active_model.start_operation operation_name,true
			end
			extend_form_to_face( ce , ps1 , tf1 , fc2 , tf2 ,true )
			Sketchup.active_model.commit_operation
		end
	end
	def extend_form_to_face( ce , ps1 , tf1 , fc2 , tf2, multi = false )
		if ce.get_attribute( "BEAM_SPECS","CLASS" ) == "MWALL"
			if multi == false
				operation_name = langconv("Extend to face")
				if Sketchup.version.to_f < 7.0
					Sketchup.active_model.start_operation operation_name
				else
					Sketchup.active_model.start_operation operation_name,true
				end
			end
			ce.entities.each{|ent|
				if ent.get_attribute( "BEAM_SPECS","CLASS" ,nil ) != nil
					ent.make_unique
					plane2 = fc2.plane
					plane2 = [fc2.vertices[0].position.transform(tf2),fc2.normal.transform(tf2)] if tf2 != nil
					tf22 = tf1.inverse * tf2
					pt22 = fc2.vertices[0].position.transform( tf22 )
					vec22 = fc2.normal.transform( tf22 )
					plane22 = [ pt22 , vec22 ]
					extend_form_face_do( ent , tf1 , ps1 , plane2 , plane22 )
				end
			}
			Sketchup.active_model.commit_operation if multi == false
		else
			plane2 = fc2.plane
			plane2 = [fc2.vertices[0].position.transform(tf2),fc2.normal.transform(tf2)] if tf2 != nil
			tf22 = tf1.inverse * tf2
			pt22 = fc2.vertices[0].position.transform( tf22 )
			vec22 = fc2.normal.transform( tf22 )
			plane22 = [ pt22 , vec22 ]
			if multi == false
				operation_name = langconv("Extend to face")
				if Sketchup.version.to_f < 7.0
					Sketchup.active_model.start_operation operation_name
				else
					Sketchup.active_model.start_operation operation_name,true
				end
			end
			
			extend_form_face_do( ce , tf1 , ps1 , plane2 , plane22 )
			Sketchup.active_model.commit_operation if multi == false
		end
	end
	def extend_form_face_do( ce , tf1 , ps1 , plane2 , plane22 )#####################
	#まず　構造フォームの開始面と終了面を取り出す
		cform1 = ce
		cform1 = ce.definition if ce.kind_of? Sketchup::ComponentInstance
		fc_start = get_startface( cform1 )
		fc_end = get_endface( cform1 )
		xvec = Geom::Vector3d.new(1,0,0)
	#開始面、終了面、クリック点からの延長線を定義
		spt = fc_start[0].vertices[0].position.transform(tf1)
		ept = fc_end[0].vertices[0].position.transform(tf1)
		ppt = ps1
		sline = [ spt , xvec.transform(tf1) ]
		eline = [ ept , xvec.transform(tf1) ]
		pline = [ ppt , xvec.transform(tf1) ]
	#延長先の面のプレーンを定義
		#plane2 = fc2.plane
		#plane2 = [fc2.vertices[0].position.transform(tf2),fc2.normal.transform(tf2)] if tf2 != nil
	#それぞれの交点を求める
		ipt_s = Geom.intersect_line_plane(sline, plane2)
		ipt_e = Geom.intersect_line_plane(eline, plane2)
		ipt_p = Geom.intersect_line_plane(pline, plane2)
		return if ipt_s == nil or ipt_e == nil or ipt_p == nil
	#それぞれの延長距離
		dist_s = ipt_s.distance( spt )
		dist_e = ipt_e.distance( ept )
		dist_p = ipt_p.distance( ppt )
		vec_s = spt.vector_to( ipt_s )
		vec_e = ept.vector_to( ipt_e )
		vec_p = ppt.vector_to( ipt_p )
	#fc1に移動すべき面を代入する
		modpos = "start"
	#既に延長先に接している場合
		if vec_s.length == 0
			fc1 = fc_start
		elsif vec_e.length == 0
			fc1 = fc_end
			modpos = "end"
		elsif vec_s.samedirection?( vec_p ) and vec_e.samedirection?( vec_p )
			if dist_s < dist_e
				fc1 = fc_start
			else
				fc1 = fc_end
				modpos = "end"
			end
		elsif vec_s.samedirection?( vec_p )
			fc1 = fc_end
			modpos = "end"
		else
			fc1 = fc_start
		end

			
		#fc1の属するグループの座標系の中で交点計算をしないで、交点を逆算する
		
		xvec = Geom::Vector3d.new(1,0,0)
		#fc1.each{|fc|
		#	extend_do( cform1 , fc , tf1 , plane2 , xvec )
		#}
		extend_do_fcs( cform1 , fc1 , tf1 , plane2 , xvec , modpos )

		#Sketchup.active_model.commit_operation
	end####################
end
end#module