require 'building_structure_tool/tst1_mod_extend_face_to_plane.rb'
##Changed in 120904:Bugfix
module TAK2HATA::BuildingStrcutureTool
module TST1_mod_grow_to_face
	include TST1_mod_extend_face_to_plane
	def second_entity_clicked2( ces , ps1 , tf1 , fc2 , tf2 , exist_sels = false )
		operation_name = langconv( "Grow to face" )
		if Sketchup.version.to_f < 7.0
			Sketchup.active_model.start_operation operation_name
		else
			Sketchup.active_model.start_operation operation_name,true
		end

		if exist_sels == true
			ces.each{|ce|
				tf1 = ce.transformation
				ps1 = ce.bounds.center
				grow_form_to_face( ce , ps1 , tf1 , fc2 , tf2 , true )
			}
		else
			ce = ces[0]
			grow_form_to_face( ce , ps1 , tf1 , fc2 , tf2 ,true )
		end
		Sketchup.active_model.commit_operation
	end
	def grow_form_to_face( ce , ps1 , tf1 , fc2 , tf2 ,multi = false )
		if ce.get_attribute( "BEAM_SPECS","CLASS" ) == "MWALL"
			if multi == false
				operation_name = langconv( "Grow to face" )
				if Sketchup.version.to_f < 7.0
					Sketchup.active_model.start_operation operation_name
				else
					Sketchup.active_model.start_operation operation_name,true
				end
			end
			ce.entities.each{|ent|
				if ent.get_attribute( "BEAM_SPECS","CLASS" ,nil ) != nil
					ent.make_unique
					plane2 = fc2.plane
					plane2 = [fc2.vertices[0].position.transform(tf2),fc2.normal.transform(tf2)] if tf2 != nil
					tf22 = tf1.inverse * tf2
					pt22 = fc2.vertices[0].position.transform( tf22 )
					vec22 = fc2.normal.transform( tf22 )
					plane22 = [ pt22 , vec22 ]
					grow_form_to_face_do( ent , tf1 , ps1 , plane2 , plane22 , fc2 , tf2 )
				end
			}
			Sketchup.active_model.commit_operation if multi == false
		else
			plane2 = fc2.plane
			plane2 = [fc2.vertices[0].position.transform(tf2),fc2.normal.transform(tf2)] if tf2 != nil
			tf22 = tf1.inverse * tf2
			pt22 = fc2.vertices[0].position.transform( tf22 )
			vec22 = fc2.normal.transform( tf22 )
			plane22 = [ pt22 , vec22 ]
			if multi == false
				operation_name = langconv( "Grow to face" )
				if Sketchup.version.to_f < 7.0
					Sketchup.active_model.start_operation operation_name
				else
					Sketchup.active_model.start_operation operation_name,true
				end
			end

			grow_form_to_face_do( ce , tf1 , ps1 , plane2 , plane22 , fc2 , tf2 )
			Sketchup.active_model.commit_operation if multi == false
		end
	end
	def grow_form_to_face_do( ce , tf1 , ps1 , plane2 , plane22 , fc2 , tf2 )
	#@ce is current form 
	#@tf1 = @ip.transformation
	#@ps1 = @ip.position
	#@fc2 is extendto face
	#@tf2 = @ip.transformation
	#まず　構造フォームの開始面と終了面を取り出す
		cform1 = ce
		cform1 = ce.definition if ce.kind_of? Sketchup::ComponentInstance
		bclass = ce.get_attribute("BEAM_SPECS","CLASS")
		if bclass[/COLUMN/]
			fc_start = get_startface( cform1 )
			fc_end = get_endface( cform1 )
			zvec = Geom::Vector3d.new(1,0,0)
			#UI.messagebox "COLUMN"
		else
			fc_start = get_bottomface( cform1 )
			fc_end = get_topface( cform1 )
			zvec = Geom::Vector3d.new(0,0,1)
		end
		return nil if fc_start == nil or fc_end == nil
		
		xvec = Geom::Vector3d.new(1,0,0)
		#zvec = Geom::Vector3d.new(0,0,1)
	#開始面、終了面、クリック点からの延長線を定義
		spt = fc_start[0].vertices[0].position.transform(tf1)
		ept = fc_end[0].vertices[0].position.transform(tf1)

		ppt = ps1
		sline = [ spt , zvec.transform(tf1) ]
		eline = [ ept , zvec.transform(tf1) ]
		pline = [ ppt , zvec.transform(tf1) ]
	#延長先の面のプレーンを定義
		plane2 = fc2.plane
		plane2 = [fc2.vertices[0].position.transform(tf2),fc2.normal.transform(tf2)] if tf2 != nil
	#それぞれの交点を求める
		ipt_s = Geom.intersect_line_plane(sline, plane2)
		ipt_e = Geom.intersect_line_plane(eline, plane2)
		ipt_p = Geom.intersect_line_plane(pline, plane2)
		return if ipt_s == nil or ipt_e == nil or ipt_p == nil
	#それぞれの延長距離
		dist_s = ipt_s.distance( spt )
		dist_e = ipt_e.distance( ept )
		dist_p = ipt_p.distance( ppt )
		vec_s = spt.vector_to( ipt_s )
		vec_e = ept.vector_to( ipt_e )
		vec_p = ppt.vector_to( ipt_p )
	#fc1に移動すべき面を代入する
		modpos = "start"
	#既に延長先に接している場合
		if vec_s.length == 0
			fc1 = fc_start
		elsif vec_e.length == 0
			fc1 = fc_end
			modpos = "end"
		elsif vec_p.length == 0
			fc1 = fc_end
			modpos = "end"
		elsif vec_s.samedirection?( vec_p ) and vec_e.samedirection?( vec_p )
			if dist_s < dist_e
				fc1 = fc_start
			else
				fc1 = fc_end
				modpos = "end"
			end
		elsif vec_s.samedirection?( vec_p )
			fc1 = fc_end
			modpos = "end"
		else
			fc1 = fc_start
		end
		vec_arr = []
		vt_arr = []
		
		#grp = fc1.parent
		
		pt22 = fc2.vertices[0].position.transform( tf1.inverse * tf2 )
		vec22 = fc2.normal.transform( tf1.inverse * tf2 )
		plane22 = [ pt22 , vec22 ]
	#fc1の属するグループの座標系の中で交点計算をする

		zvec = Geom::Vector3d.new(0,0,1)
		#fc1.each{|fc|
		#	extend_do( cform1 , fc , tf1 , plane2 , zvec )
		#}
		extend_do_fcs( cform1 , fc1 , tf1 , plane2 , zvec )
		#Sketchup.active_model.commit_operation

	end

end # of class

end#module