jQuery(document).ready(function()
{
/*
"STEEL_COLUMN"
"RC_COLUMN"
"RC_WALL"
"MWALL"
"SHAPES"
"STEEL_BEAM"
"RC_BEAM"
"STEEL_GIRDER"
"ALL"
"RC_FOOTING"
"SLAB"
*/
    var mydata = [
       {tag:"B1", profile:"H-100x100x8x12", gap_level:"0", solidmat:"CONCRETE", rotation:"0", fmat:"matCONC", bmat:"BLACK", secmat:"matCONC2"},
       {tag:"B2", profile:"H-100x100x8x12", gap_level:"0", solidmat:"CONCRETE", rotation:"0", fmat:"matCONC", bmat:"BLACK", secmat:"matCONC2"},
       {tag:"B3", profile:"H-100x100x8x12", gap_level:"0", solidmat:"CONCRETE", rotation:"0", fmat:"matCONC", bmat:"BLACK", secmat:"matCONC2"},
    ];
    jQuery("#list").jqGrid({
        data: mydata,
        datatype: "local",
        colNames:['TAG', 'PROFILE', 'GAP TOP LEVEL', 'SOLID MATERIAL', 'ROTATION', 'FRONT MAT', 'BACK MAT', 'SECTION MAT'],
        // 編集可能にするセルを editable:true にします。
        colModel:[
            {index:'tag', name:'tag', width:80, editable:true },
            {index:'profile', name:'profile', width:140, editable:true },
            {index:'gap_level', name:'gap_level', width:80, editable:true },
            {index:'solidmat', name:'solidmat', width:80, editable:true },
            {index:'rotation', name:'rotation', width:80, editable:true },
            {index:'fmat', name:'fmat', width:80, editable:true },
            {index:'bmat', name:'bmat', width:80, editable:true },
            {index:'secmat', name:'secmat', width:80, editable:true },
        ],
        width: 700,
        cellEdit: true,    // true: クリックしたセルの編集
        scroll:true,
        multiselect: true,
        caption: 'STEEL GIRDER'
    }); 
});
