require 'sketchup.rb'
require 'building_structure_tool/tst1_mod_common_util.rb'
require 'building_structure_tool/tst1_mod_bst_table_editor_dummy.rb'
module TAK2HATA::BuildingStrcutureTool
class TST1_class_table_editor
		include TST1_mod_common_util
		include TST1_mod_bst_table_editor_dummy
		def show_tooldialog()
			if $bst_tedit_wdlg
				$bst_tedit_wdlg.bring_to_front
				#UI.messagebox "Table editor is already running"
				return
			end
			#pfolder = File::dirname( bst_u8tosjis( Sketchup.find_support_files( "", "Plugins" )[0] ) )
			#tedlgpath = File.expand_path( File.join( pfolder , "building_structure_tool","bst_table_editor.html" ))
			#if File.exists?(tedlgpath)
				tbuff = bst_table_editor_dummy() #readtextfile( tedlgpath )
				tbuff = langconv_html(tbuff)
				if tbuff != nil
					bst_folder_path = bst_file_dirname( __FILE__ )
					tarr = tbuff.split(/[\n\r]+/)
					bstlist = ["OTHER","STEEL_GIRDER","STEEL_BEAM","STEEL_COLUMN","RC_GIRDER","RC_BEAM","RC_COLUMN","RC_WALL","RC_FOOTING","SLAB"]
					pfpath = ""
					pflisthash , pfpath = readProfiles( "" )
					(tarr.size).times{|i|
						bstlist.each{|bl|
							if tarr[i].include?('//' + bl + '_DATA_STORE//')
								#$bst_parts_units is gotten in this time.
								stgdata = []
								pflisthash[bl].each{|pf|
									tmpdata = []
									if pf and pf.strip.chomp != ""
										pfarr = pf.split("\t")
										tmpdata.push( "tag:" + '"' + pfarr[0].gsub(/\"/,'\"') + '"' ) if pfarr[0]
										tmpdata.push( "profile:" + '"' + pfarr[1].gsub(/\"/,'\"') + '"' ) if pfarr[1]
										tmpdata.push( "gap_level:" + '"' + pfarr[2].gsub(/\"/,'\"') + '"') if pfarr[2]
										tmpdata.push( "solidmat:" + '"' + pfarr[3].gsub(/\"/,'\"') + '"') if pfarr[3]
										tmpdata.push( "rotation:" + '"' + pfarr[4].gsub(/\"/,'\"') + '"') if pfarr[4]
										tmpdata.push( "fmat:" + '"' + pfarr[5].gsub(/\"/,'\"') + '"') if pfarr[5]
										tmpdata.push( "bmat:" + '"' + pfarr[6].gsub(/\"/,'\"') + '"') if pfarr[6]
										tmpdata.push( "secmat:" + '"' + pfarr[7].gsub(/\"/,'\"') + '"') if pfarr[7]
										stgdata.push( "{" + tmpdata.join(",") + "}" )
									end
								}
								tarr[i] = "database = [\n" + stgdata.join(",\n") + "\n];"
								break
							end
						}
					}
					tbuff = tarr.join("\n")
					prfkeys = { 
						:dialog_title => 'BST Table Editor>>' + pfpath , 
						:scrollable => true, 
						:preferences_key => 'tst_bst_table_editor', 
						:height => 445, 
						:width => 980, 
						:left => 150, 
						:top => 150, 
						:resizable => true, 
						:mac_only_use_nswindow => true
					}
					$bst_tedit_wdlg = UI::WebDialog.new( prfkeys )
					bst_folder_path.gsub!(/\\/,"/")
					tbuff.gsub!("//BST_FOLDER//",bst_folder_path)
					#wdlgpath = File.join( bst_folder_path , "bst_table_editor2.html" )
=begin
					fs = open( wdlgpath , "w+" )
					if fs
						p "show webdialog by FILE"
						tbuff.gsub!("//BST_FOLDER//","")
						fs.puts tbuff
						fs.close
						$bst_tedit_wdlg.set_file( wdlgpath )
						tbuff = nil
					else
=end
						p "show webdialog by CODE"
						bst_folder_path.gsub!(/\\/,"/")
						tbuff.gsub!("//BST_FOLDER//",bst_folder_path)
						$bst_tedit_wdlg.set_html( tbuff )
					##end
				end
			#else
			#	UI.messagebox("Table Editor was not found.\n(Notice:the one of cause is sketchup installed path inluding No-English Character.")
			#	return
			#end
			$bst_tedit_wdlg.set_on_close{
				$bst_tedit_wdlg = nil
			}
			$bst_tedit_wdlg.add_action_callback("load_file"){|d,prm|
				res = change_defaultPFPath()
				if res != false
					$bst_tedit_wdlg.close
					$bst_tedit_wdlg = nil
					self.show_tooldialog()
				end
			}

			$bst_tedit_wdlg.add_action_callback("buff_save"){|d,prm|
				schema_units = "mm"
				if $bst_tedit_wdlg.get_element_value("SCHEMA_UNITS")
					schema_units = $bst_tedit_wdlg.get_element_value("SCHEMA_UNITS")
				end
				tbuff = $bst_tedit_wdlg.get_element_value("SENDTEXT")
				#bstclass = $bst_tedit_wdlg.get_element_value("BSTCLASS")
				#UI.messagebox( bstclass );
				if tbuff.strip != ""
					tccheck = $bst_tedit_wdlg.get_element_value("TSV_CSV")
					databuff = []
					aline = "#(0)TAG	(1)Profile	(2)GAP_LEVEL	(3)SOLID MATERIAL	(4)Rotate	(5)FrontColor	(6)BackColor	(7)SectionColor"
					bline = "#SETTINGS	JISTYPE	" + schema_units + ( "\t" * 5 )
					databuff.push aline
					databuff.push bline
					databuff.push tbuff.split("|||")  ##.map{|tb| tb.gsub("|||||||","\t") }
					databuff.flatten!
					if tccheck == "csv" or tccheck == "tsv"
						saveProfileList( databuff , tccheck )
					else
						saveProfileList( databuff )
					end
					if tccheck == "csv"
					else
						bstclass = $bst_tedit_wdlg.get_element_value("BSTCLASS")
						if $bst_tool_wdlg and bstclass
							jcmd = "changedBstClass('" + bstclass + "')"
							$bst_tool_wdlg.execute_script(jcmd)
						end
					end
					databuff = nil
					$bst_tedit_wdlg.execute_script("clear_sendbox()")
				end
			}
			$bst_tedit_wdlg.add_action_callback("set_bstdia"){|d,prm|
				bstclass = $bst_tedit_wdlg.get_element_value("BSTCLASS")
				if $bst_tool_wdlg and bstclass
					jcmd = "changedBstClass('" + bstclass + "')"
					$bst_tool_wdlg.execute_script(jcmd)
				end
			}
			
			jcmd = "selectListbox('" + $bst_parts_units + "')"
			
			if RUBY_PLATFORM[/darwin/]
				$bst_tedit_wdlg.show_modal { $bst_tedit_wdlg.execute_script(jcmd) }
			else
				$bst_tedit_wdlg.show { $bst_tedit_wdlg.execute_script(jcmd) }
			end
		end

end#class
end#module
