#Extend_Trim_structures.　（ExtendStructures(Face)）
# Copyright TAK2
##require 'sketchup.rb'
module TAK2HATA::BuildingStrcutureTool
module TST1_mod_extend_face_to_plane
	def extend_do_fcs( ce , fcs , tf1 , plane2 , xvec = Geom::Vector3d.new(1,0,0) , modpos = "no" )#####################
	#fc
		vec_arr = []
		vt_arr = []
		fcs.each{|fc|
			fc.edges.each{|ed|
				ed.explode_curve if ed.curve
			}
			fc1ed_IDs = []
			fc.edges.each{|ed|
				fc1ed_IDs.push ed.entityID
			}

			fc.vertices.each{|vt|
				if vt.curve_interior?
				else
					vtp = vt.position.transform( tf1 )

					vline = [ vtp ,  xvec.transform( tf1 ) ]
					ed1 = vt.edges.find_all{|ed| fc1ed_IDs.index( ed.entityID ) == nil }
					
					if ed1 != [] and ed1.size == 1
						ed2 = ed1.find_all{|ed| ed.visible? }
						if ed2.size == 1
							#vline = [ ed1[0].line[0].transform( tf1 ) , ed1[0].line[1].transform( tf1 ) ]
							vpos = ed1[0].start.position
							vec_ed = ed1[0].start.position.vector_to(ed1[0].end.position)
							if vec_ed.length > 0
								vline = [ vpos.transform( tf1 ) , vec_ed.transform( tf1 ) ]
							end
						end
					end
					ipt_v = Geom.intersect_line_plane( vline, plane2 )
					vec_v = vtp.vector_to( ipt_v )
					#if vt.curve_interior?
					#	grp.entities.add_edges [ vtp ,ipt_v ]
					#end
					if vt_arr.find_all{|vta| vta == vt } == []
					if vec_v.length != 0
						vt_arr.push vt
						vec_arr.push vec_v.transform( tf1.inverse )
					end
					end
				end
			}
		}
		return if vt_arr == nil
		return if vt_arr.size == 0
		ce.entities.transform_by_vectors vt_arr , vec_arr
		modify_cline( ce , tf1 , modpos , xvec , plane2 ) if modpos != "no"
		#Sketchup.active_model.commit_operation
	end####################
	def extend_do( ce , fc , tf1 , plane2 , xvec = Geom::Vector3d.new(1,0,0) )#####################
		vec_arr = []
		vt_arr = []
			fc.edges.each{|ed|
				ed.explode_curve if ed.curve
			}
			fc1ed_IDs = []
			fc.edges.each{|ed|
				fc1ed_IDs.push ed.entityID
			}

			fc.vertices.each{|vt|
				if vt.curve_interior?
				else
					vtp = vt.position.transform( tf1 )
					vline = [ vtp ,  xvec.transform( tf1 ) ]
					ed1 = vt.edges.find_all{|ed| fc1ed_IDs.index( ed.entityID ) == nil }
					
					if ed1 != [] and ed1.size == 1
						ed2 = ed1.find_all{|ed| ed.visible? }
						if ed2.size == 1
							vline = [ ed1[0].line[0].transform( tf1 ) , ed1[0].line[1].transform( tf1 ) ]
						end
					end
					

					ipt_v = Geom.intersect_line_plane( vline, plane2 )
					vec_v = vtp.vector_to( ipt_v )
					#if vt.curve_interior?
					#	grp.entities.add_edges [ vtp ,ipt_v ]
					#end
					if vt_arr.find_all{|vta| vta == vt } == []
					if vec_v.length != 0
						vt_arr.push vt
						vec_arr.push vec_v.transform( tf1.inverse )
					end
					end
				end
			}

		return if vt_arr == nil
		return if vt_arr.size == 0
		ce.entities.transform_by_vectors vt_arr , vec_arr
		#Sketchup.active_model.commit_operation
	end####################
	def modify_cline( grp , tf1 , modpos , xvec , plane2)
		#構築線も修正する
		pts = []
		pts = grp.get_attribute( "BEAM_SPECS","PATH" ) if grp.get_attribute( "BEAM_SPECS","PATH" )
		grp.entities.each{|e|
			if e.typename == "ConstructionLine"
				if e.direction.parallel?( xvec )
					cpt = e.start
					cline = [ cpt.transform(tf1) , xvec.transform(tf1) ]
					ipt_c = Geom.intersect_line_plane( cline, plane2 )
					if modpos == "start"
						e.start = ipt_c.transform( tf1.inverse )
						pts[0] = e.start
					else
						e.end = ipt_c.transform( tf1.inverse )
						pts[1] = e.end
					end
				end
			end
		}
		grp.set_attribute "BEAM_SPECS","PATH", pts

	end
end # of module
end#module
