#modified in 2013 02 19
module TAK2HATA::BuildingStrcutureTool
module TST1_mod_profile_gen
		def add_Hshape_face(  grp , gw , gh , gt1 , gt2 , r1 = 0.0 )
			ents = grp.entities
			shapePts = []
			holePts = []
			if r1 == 0.0
				shapePts.push [ 0 , -gw/2, gh/2 ]			#1
				shapePts.push [ 0 , gw/2 , gh/2 ]			#2
				shapePts.push [ 0 , gw/2 , (gh/2 - gt2) ]	#3
				shapePts.push [ 0 , gt1/2, (gh/2 - gt2) ]	#4
				shapePts.push [ 0 , gt1/2, (-gh/2 + gt2) ]	#5
				shapePts.push [ 0 , gw/2 , (-gh/2 + gt2) ]	#6
				shapePts.push [ 0 , gw/2 , -gh/2 ]			#7
				shapePts.push [ 0 , -gw/2, -gh/2 ]			#8
				shapePts.push [ 0 , -gw/2, (-gh/2 + gt2) ]	#9
				shapePts.push [ 0 , -gt1/2, (-gh/2 + gt2) ]	#10
				shapePts.push [ 0 , -gt1/2, (gh/2 - gt2) ]	#11
				shapePts.push [ 0 , -gw/2, (gh/2 - gt2) ]	#12
				fc = ents.add_face shapePts
			else
				#H-AxBxCxDxR
				xa = gw/2
				xb = gt1/2
				xc = gt1/2+r1
				ya = gh/2
				yb = gh/2-gt2
				yc = gh/2-gt2-r1
				xvec = Geom::Vector3d.new 0,1,0
				zvec = Geom::Vector3d.new 1,0,0
				ed1 = ents.add_edges( [ [0,-xc,yb],[0,-xa,yb],[0,-xa,ya],[0,xa,ya],[0,xa,yb],[0,xc,yb] ] )
				ed2 = ents.add_edges( [ [0,xc,-yb],[0,xa,-yb],[0,xa,-ya],[0,-xa,-ya],[0,-xa,-yb],[0,-xc,-yb] ] )
				ed3 = ents.add_edges([ [0,xb,yc],[0,xb,-yc] ] )
				ed4 = ents.add_edges([ [0,-xb,-yc],[0,-xb,yc] ] )
				ed5 = add_arcedges( ents , [0,xc,yc] , r1 , 90.degrees , 180.degrees , 2 )#entities,center,radius,ang1,ang2,divides
				ed6 = add_arcedges( ents , [0,xc,-yc] , r1 , 180.degrees, 270.degrees, 2 )
				ed7 = add_arcedges( ents , [0,-xc,-yc] , r1 , 270.degrees, 360.degrees, 2 )
				ed8 = add_arcedges( ents , [0,-xc,yc] , r1 , 0.degrees, 90.degrees, 2 )
				
				#ed5 = ents.add_arc([0,xc,yc], xvec, zvec, r1 ,90.degrees, 180.degrees, 2 )
				#ed6 = ents.add_arc([0,xc,-yc], xvec, zvec, r1 , 180.degrees, 270.degrees, 2 )
				#ed7 = ents.add_arc([0,-xc,-yc], xvec, zvec, r1 , 270.degrees, 360.degrees, 2 )
				#ed8 = ents.add_arc([0,-xc,yc], xvec, zvec, r1 , 0.degrees, 90.degrees, 2 )
				#UI.messag
				fc = ents.add_face([ed1,ed2,ed3,ed4,ed5,ed6,ed7,ed8].flatten )
			end
			return nil if fc == nil
			return fc
		end
		def add_SHshape_face(  grp , gw , gh , gt1 , r1 = 0.0 )
			ents = grp.entities
			shapePts = []
			holePts = []
			if r1 == 0.0
				shapePts.push [ 0 , -gw/2, gh/2 ]			#1
				shapePts.push [ 0 , gw/2 , gh/2 ]			#2
				shapePts.push [ 0 , gw/2 , -gh/2 ]			#3
				shapePts.push [ 0 , -gw/2, -gh/2 ]			#4
				holePts.push [ 0,-gw/2 + gt1 , gh/2 - gt1 ]
				holePts.push [ 0 , gw/2 - gt1 , gh/2 - gt1 ]			#2
				holePts.push [ 0 , gw/2 - gt1 , -gh/2 + gt1 ]			#3
				holePts.push [ 0 , -gw/2 + gt1 , -gh/2 + gt1 ]			#4
				fc = ents.add_face shapePts
				hole = ents.add_face holePts
				ents.erase_entities hole
			else
				xa = gw/2
				xb = gw/2 - gt1
				xc = gw/2 - r1
				ya = gh/2
				yb = gh/2 - gt1
				yc = gh/2 - r1
				xvec = Geom::Vector3d.new 0,1,0
				zvec = Geom::Vector3d.new 1,0,0

				ed = []
				ed[0] = ents.add_edges( [ [0,xa,yc],[0,xa,-yc] ] )
				ed[1] = ents.add_edges( [ [0,xc,-ya],[0,-xc,-ya] ] )
				ed[2] = ents.add_edges( [ [0,-xa,-yc],[0,-xa,yc] ] )
				ed[3] = ents.add_edges( [ [0,-xc,ya],[0,xc,ya] ] )
				
				ed[4] = add_arcedges( ents , [0,xc,-yc], r1 ,270.degrees, 360.degrees, 2 )
				ed[5] = add_arcedges( ents , [0,-xc,-yc], r1 ,180.degrees, 270.degrees, 2 )
				ed[6] = add_arcedges( ents , [0,-xc,yc], r1 ,90.degrees, 180.degrees, 2 )
				ed[7] = add_arcedges( ents , [0,xc,yc], r1 ,0.degrees, 90.degrees, 2 )
				#ed[4] = ents.add_arc([0,xc,-yc], xvec, zvec, r1 ,270.degrees, 360.degrees, 2 )
				#ed[5] = ents.add_arc([0,-xc,-yc], xvec, zvec, r1 ,180.degrees, 270.degrees, 2 )
				#ed[6] = ents.add_arc([0,-xc,yc], xvec, zvec, r1 ,90.degrees, 180.degrees, 2 )
				#ed[7] = ents.add_arc([0,xc,yc], xvec, zvec, r1 ,0.degrees, 90.degrees, 2 )
				fc = ents.add_face( ed.flatten )
				
				ed = []
				ed[0] = ents.add_edges( [ [0,xb,yc],[0,xb,-yc] ] )
				ed[1] = ents.add_edges( [ [0,xc,-yb],[0,-xc,-yb] ] )
				ed[2] = ents.add_edges( [ [0,-xb,-yc],[0,-xb,yc] ] )
				ed[3] = ents.add_edges( [ [0,-xc,yb],[0,xc,yb] ] )
				ed[4] = add_arcedges( ents , [0,xc,-yc], ( r1 - gt1 ) ,270.degrees, 360.degrees, 2 )
				ed[5] = add_arcedges( ents , [0,-xc,-yc], ( r1 - gt1 ) ,180.degrees, 270.degrees, 2 )
				ed[6] = add_arcedges( ents , [0,-xc,yc], ( r1 - gt1 ) ,90.degrees, 180.degrees, 2 )
				ed[7] = add_arcedges( ents , [0,xc,yc], ( r1 - gt1 ) ,0.degrees, 90.degrees, 2 )
				#ed[4] = ents.add_arc([0,xc,-yc], xvec, zvec, ( r1 - gt1 ) ,270.degrees, 360.degrees, 2 )
				#ed[5] = ents.add_arc([0,-xc,-yc], xvec, zvec, ( r1 - gt1 ) ,180.degrees, 270.degrees, 2 )
				#ed[6] = ents.add_arc([0,-xc,yc], xvec, zvec, ( r1 - gt1 ) ,90.degrees, 180.degrees, 2 )
				#ed[7] = ents.add_arc([0,xc,yc], xvec, zvec, ( r1 - gt1 ) ,0.degrees, 90.degrees, 2 )
				hole = ents.add_face( ed.flatten )
				ents.erase_entities hole
			end
			return nil if fc == nil
			return fc
		end
		def add_CHshape_face(  grp , gw , gh , gt1 , r )
			ents = grp.entities
			shapePts = []
			holePts = []
			(0..24).each{|cnt|
				ang = ( 360.to_f / 24 * cnt.to_f ).degrees
				shapePts.push [ 0 , Math.sin( ang ) * r , Math.cos( ang ) * r ]
				holePts.push [ 0 , Math.sin( ang ) * ( r - gt1 ), Math.cos( ang ) * ( r - gt1 ) ]
			}
			crv = ents.add_curve shapePts
			crv2 = ents.add_curve holePts
			fc = ents.add_face shapePts
			hole = ents.add_face holePts
			ents.erase_entities hole

			return nil if fc == nil
			return fc
		end
		def add_Lshape_face( grp , gw , gh , gt1 , gt2 ,r1 , r2)
			ents = grp.entities
			xa = gw / 2
			xb = xa - r2
			xc = xa - gt1
			xd = xa - gt1 - r1
			xe = xa - gt1 + r2
			ya = gh / 2
			yb = ya - r2
			yc = ya - gt2
			yd = ya - gt2 - r1
			ye = ya - gt2 + r2
			xvec = Geom::Vector3d.new 0,1,0
			zvec = Geom::Vector3d.new 1,0,0
			if r1 == 0.0 or r2 == 0.0
				fc = ents.add_face( [ [0,-xc,-ya],[0,-xa,-ya],[0,-xa,ya],[0,xa,ya],[0,xa,yc],[0,-xc,yc] ] )
			else
				ed = []
				ed[0] = ents.add_edges( [[0,-xe,-ya],[0,-xa,-ya],[0,-xa,ya],[0,xa,ya],[0,xa,ye]] )
				ed[1] = ents.add_edges( [[0,xb,yc],[0,-xd,yc]] )
				ed[2] = ents.add_edges( [[0,-xc,yd],[0,-xc,-yb]] )
				ed[3] = add_arcedges( ents , [0,xb,ye], r2 ,270.degrees, 360.degrees, 2 )
				ed[4] = add_arcedges( ents , [0,-xe,-yb], r2 ,270.degrees, 360.degrees, 2 )
				ed[5] = add_arcedges( ents , [0,-xd,yd], r1 ,90.degrees, 180.degrees, 2 )
				#ed[3] = ents.add_arc([0,xb,ye], xvec, zvec,  r2 ,270.degrees, 360.degrees, 2 )
				#ed[4] = ents.add_arc([0,-xe,-yb], xvec, zvec,  r2 ,270.degrees, 360.degrees, 2 )
				#ed[5] = ents.add_arc([0,-xd,yd], xvec, zvec,  r1 ,90.degrees, 180.degrees, 2 )						
				fc = ents.add_face( ed.flatten )

			end
			return nil if fc == nil
			return fc
		end
		def add_CCshape_face( grp , gw , gh , t1 , t2 , r1 , r2 )#Mizogata
			ents = grp.entities
			shapePts = []
			holePts = []
			
			if r1 == 0.0 or r2 == 0.0
				xa = gw / 2
				xb = xa - t1
				ya = gh / 2
				yb = ya - t2
				fc = ents.add_face( [[0,-xa,-ya],[0,-xa,ya],[0,xa,ya],[0,xa,yb],[0,-xb,yb],[0,-xb,-yb],[0,xa,-yb],[0,xa,-ya]] )
			else
				#[-ghxgwxt1xt2xr1xr2
				#UI.messagebox "#{gw} ,#{gh} , #{t1} , #{t2} , #{r1} , #{r2}"
				ang = Math::PI * 5.0 / 180.0
				x0 = -gw / 2
				xa = gw / 2
				xb = x0 + t1
				xc = xb + r1 * Math.cos( ang )
				xe = xa - r2 * Math.cos( ang )
				xf = t1 / 2
				ya = gh / 2
				yj = ya - t2 + Math.sin( ang ) * (xe - xf).abs
				yk = ya - t2 - Math.sin( ang ) * (xc - xf).abs
				yi = yj + r2 * Math.cos( ang )
				yl = yk - r1 * Math.cos( ang )
				#UI.messagebox "#{x0} ,#{xa} , #{xb} , #{xc} , #{xe} , #{xf}\n#{ya} , #{yi} , #{yj} , #{yk} , #{yl}"
				xvec = Geom::Vector3d.new 0,1,0
				zvec = Geom::Vector3d.new 1,0,0

				ed = []
				ed[0] = ents.add_edges( [ [0,xa,-yi],[0,xa,-ya],[0,x0,-ya],[0,x0,ya],[0,xa,ya],[0,xa,yi] ] )
				ed[1] = ents.add_edges( [ [0,xe,yj],[0,xc,yk] ] )
				ed[2] = ents.add_edges( [ [0,xb,yl],[0,xb,-yl] ] )
				ed[3] = ents.add_edges( [ [0,xc,-yk],[0,xe,-yj] ] )
				

				cpt = [ 0 , xa-r2 , yi ]
				pts = []
				pts.push [0,xa,yi]
				arcpts( pts , cpt , r2 , 360.degrees , 275.degrees , 2 )
				pts.push [0,xe,yj]
				ed[4] = ents.add_curve( pts )
				#ed[4] = add_arcedges( ents ,  cpt , r2 , 360.degrees , 275.degrees , 2 )
				#ed[4] = ents.add_curve( [ [0,xa,yi] ,[ 0 , xa-r2 + r2 * Math.cos( ang.degrees ) , yi + r2 * Math.sin( ang.degrees )] , [0,xe,yj] ] )
				#ed[4] = ents.add_arc([0,xa-r2,yi], xvec, zvec,  r2 ,275.degrees, 360.degrees, 2 )

				cpt = [ 0 , xa-r2 ,-yi ]
				pts = []
				pts.push [0,xe,-yj]
				arcpts( pts , cpt , r2 , 85.degrees , 0.degrees , 2 )
				pts.push [0,xa,-yi]
				#ed[5] = add_arcedges( ents ,  cpt , r2 , 85.degrees , 0.degrees , 2 )
				ed[5] = ents.add_curve( pts )
				#ang = ( 0 + 85 ) / 2
				#ed[5] = ents.add_curve( [ [0,xe,-yj] ,[ 0 , xa-r2 + r2 * Math.cos( ang.degrees ) , -yi + r2 * Math.sin( ang.degrees )] , [0,xa,-yi] ] )
				#ed[5] = ents.add_arc([0,xa-r2,-yi], xvec, zvec,  r2 , 0.degrees, 85.degrees, 2 )
				
				cpt = [ 0 , x0 + t1 + r1 , yl ]
				pts = []
				pts.push [0,xb,yl]
				arcpts( pts , cpt , r1 , 95.degrees , 180.degrees , 4 )
				pts.push [0,xc,yk]
				#ed[6] = add_arcedges( ents ,  cpt , r1 , 95.degrees , 180.degrees , 4 )
				ed[6] = ents.add_curve( pts )
				#ang = ( 95 + 180 ) / 2
				#ed[6] = ents.add_curve( [ [0,xb,yl] ,[ 0 , x0 + t1 + r1 + r1 * Math.cos( ang.degrees ) , yl + r1 * Math.sin( ang.degrees )] , [0,xc,yk] ] )
				#ed[6] = ents.add_arc([0,x0 + t1 + r1,yl], xvec, zvec,  r1 , 95.degrees, 180.degrees, 2 )
				cpt = [ 0 , x0 + t1 + r1 , -yl ]
				pts = []
				pts.push [0,xb,-yl]
				arcpts( pts , cpt , r1 , 275.degrees , 180.degrees , 4 )
				pts.push [0,xc,-yk]
				#ed[7] = add_arcedges( ents , cpt , r1 , 275.degrees , 180.degrees , 4 )
				ed[7] = ents.add_curve( pts )
				#ang = ( 180 + 275 ) / 2
				#ed[7] = ents.add_curve( [ [0,xb,-yl] ,[ 0 , x0 + t1 + r1 + r1 * Math.cos( ang.degrees ) , -yl + r1 * Math.sin( ang.degrees )] , [0,xc,-yk] ] )
				#ed[7] = ents.add_arc([0,x0 + t1 + r1,-yl], xvec, zvec,  r1 , 180.degrees, 275.degrees, 2 )

				fc = ents.add_face( ed.flatten )
			end
			return nil if fc == nil
			return fc
		end
		def add_shapecomp_face( grp , shapename , gw , gh )
			defs = Sketchup.active_model.definitions
			ents = grp.entities
			##compfilename_o = File.join( File.dirname( File.expand_path(__FILE__) ), "shapes" , "#{shapename}.skp" )
			compfilename_o = bst_file_join( bst_file_dirname( __FILE__ ), "shapes" , "#{shapename}.skp" )
			#Sketchup.find_support_file "#{shapename}.skp", "Plugins/building_structure_tool/shapes/"
			compfilename = bst_u8tosjis(compfilename_o)
			#if $kconvloaded == true
			#	compfilename = Kconv.tosjis(compfilename)
			#end
			return nil if not FileTest.exist?( compfilename )
			t = Geom::Transformation.new( [ 0,0,0 ] )
			cdef = defs.load compfilename
			cins = ents.add_instance( cdef , t )
			ents2 = cins.explode
			fcs = ents2.find_all{|e| e.kind_of? Sketchup::Face }
			fc = fcs[0]
			gw = fc.bounds.depth
			gh = fc.bounds.height
			return fc
		end
		def add_Cshape_face( grp , gw , gh , t1 , t2 )#Mizogata
			ents = grp.entities
			shapePts = []
			holePts = []

			#C-ghxgwxt1xt2
			xa= gw / 2
			xb= xa - t2
			xc= xa - t2 * 2
			ya= gh / 2
			yb= ya - t2
			yc= ya - t2 * 2
			yd= ya - t1

			xvec = Geom::Vector3d.new 0,1,0
			zvec = Geom::Vector3d.new 1,0,0

			ed = []
			ed[0] = ents.add_edges( [ [0,-xc,ya],[0,xc,ya] ] )
			ed[1] = ents.add_edges( [ [0,xa,yc],[0,xa,yd],[0,xb,yd],[0,xb,yc] ] )
			ed[2] = ents.add_edges( [ [0,xc,yb],[0,-xc,yb] ] )
			ed[3] = ents.add_edges( [ [0,-xb,yc],[0,-xb,-yc] ] )
			ed[4] = ents.add_edges( [ [0,-xc,-yb],[0,xc,-yb] ] )
			ed[5] = ents.add_edges( [ [0,xb,-yc],[0,xb,-yd],[0,xa,-yd],[0,xa,-yc] ] )
			ed[6] = ents.add_edges( [ [0,xc,-ya],[0,-xc,-ya] ] )
			ed[7] = ents.add_edges( [ [0,-xa,-yc],[0,-xa,yc] ] )
			#ed[8] = add_arcedges( ents ,[0,-xc,yc], ( t2 * 2 ) ,90.degrees, 180.degrees, 2 )
			#ed[9] = add_arcedges( ents ,[0,-xc,yc], ( t2 ) ,90.degrees, 180.degrees, 2 )
			#ed[10] = add_arcedges( ents ,[0,xc,yc], ( t2 * 2 ) ,0.degrees, 90.degrees, 2 )
			#ed[11] = add_arcedges( ents ,[0,xc,yc], ( t2 ) ,0.degrees, 90.degrees, 2 )
			#ed[12] = add_arcedges( ents ,[0,xc,-yc], ( t2 * 2 ) ,270.degrees, 360.degrees, 2 )
			#ed[13] = add_arcedges( ents ,[0,xc,-yc], ( t2 ) ,270.degrees, 360.degrees, 2 )
			#ed[14] = add_arcedges( ents ,[0,-xc,-yc], ( t2 * 2 ) ,180.degrees, 270.degrees, 2 )
			#ed[15] = add_arcedges( ents ,[0,-xc,-yc], ( t2 ) ,180.degrees, 270.degrees, 2 )
			ed[8] = ents.add_arc([0,-xc,yc], xvec, zvec,  ( t2 * 2 ) ,90.degrees, 180.degrees, 2 )
			ed[9] = ents.add_arc([0,-xc,yc], xvec, zvec,  ( t2 ) ,90.degrees, 180.degrees, 2 )
			ed[10] = ents.add_arc([0,xc,yc], xvec, zvec,  ( t2 * 2 ) ,0.degrees, 90.degrees, 2 )
			ed[11] = ents.add_arc([0,xc,yc], xvec, zvec,  ( t2 ) ,0.degrees, 90.degrees, 2 )
			ed[12] = ents.add_arc([0,xc,-yc], xvec, zvec,  ( t2 * 2 ) ,270.degrees, 360.degrees, 2 )
			ed[13] = ents.add_arc([0,xc,-yc], xvec, zvec,  ( t2 ) ,270.degrees, 360.degrees, 2 )
			ed[14] = ents.add_arc([0,-xc,-yc], xvec, zvec,  ( t2 * 2 ) ,180.degrees, 270.degrees, 2 )
			ed[15] = ents.add_arc([0,-xc,-yc], xvec, zvec,  ( t2 ) ,180.degrees, 270.degrees, 2 )
			fc = ents.add_face( ed.flatten )

			return nil if fc == nil
			return fc
		end
		def add_Tshape_face( grp , gw , gh , t1 , t2 , r1 )
			ents = grp.entities
			ya = gh / 2
			yb = ya - t2
			yc = yb - r1
			xa = gw / 2
			xc = t1 / 2
			xb = xc + r1
			xvec = Geom::Vector3d.new 0,1,0
			zvec = Geom::Vector3d.new 1,0,0
			if r1 == 0.0
				fc = ents.add_face( [ [0,xa,ya],[0,xa,yb],[0,xc,yb],[0,xc,-ya],[0,-xc,-ya],[0,-xc,yb],[0,-xa,yb],[0,-xa,ya] ] )
			else
				ed = []
				ed[0] = ents.add_edges( [ [0,-xb,yb],[0,-xa,yb],[0,-xa,ya],[0,xa,ya],[0,xa,yb],[0,xb,yb] ] )
				ed[1] = ents.add_edges( [ [0,xc,yc],[0,xc,-ya],[0,-xc,-ya],[0,-xc,yc] ] )
				#add_arcedges( ents ,
				ed[2] = add_arcedges( ents , [0,xb,yc], r1 , 90.degrees, 180.degrees, 2 )
				ed[3] = add_arcedges( ents , [0,-xb,yc], r1 , 0.degrees, 90.degrees, 2 )
				#ed[2] = ents.add_arc( [0,xb,yc], xvec, zvec,  r1 , 90.degrees, 180.degrees, 2 )
				#ed[3] = ents.add_arc( [0,-xb,yc], xvec, zvec,  r1 , 0.degrees, 90.degrees, 2 )
				fc = ents.add_face( ed.flatten )
			end
			return nil if fc == nil
			return fc
		end
		def add_FBshape_face( grp , gw , gh )
			ents = grp.entities
			ya = gh / 2
			xa = gw / 2
			xvec = Geom::Vector3d.new 0,1,0
			zvec = Geom::Vector3d.new 1,0,0

			fc = ents.add_face( [ [0,xa,ya],[0,xa,-ya],[0,-xa,-ya],[0,-xa,ya] ] )

			return nil if fc == nil
			return fc
		end
		def arcpts( pts , cpt , r2 , ang1 , ang2 , div )
			for d in ( 1..(div-1) )
				ang3 = ( ang1 * d + ang2 * ( div - d ) ) / div
				pts.push [ 0 , cpt.y + r2 * Math.cos( ang3 ) , cpt.z + r2 * Math.sin( ang3 )]
			end
		end
		def add_arcedges( ents , cpt , r2 , ang1, ang2 , div )#entities,center,radius,ang1,ang2,startpt,endpt,divides
			pts = []
			for d in ( 0..(div) )
				ang3 = ( ang1 * d + ang2 * ( div - d ) ) / div
				pts.push [ 0 , cpt.y + r2 * Math.cos( ang3) , cpt.z + r2 * Math.sin( ang3 )]
			end	
			ed = ents.add_curve pts
			return ed
		end
end#module
end#module